/* BOF */

/* ======================================================================= */
/* Programm:     NetzProtokolle                                            */
/* ----------------------------------------------------------------------- */
/*                                                                         */
/* Beschreibung: Simulation von Netzzugangsprotokollen fuer die lokalen    */
/*               Rechnernetze. Ethernet, (Token Ring, DQDB.)               */
/*                                                                         */
/* Ersteller:    Jochen Becher                                             */
/* Version:      0.9                                                       */
/* Datum:        09.01.1998                                                */
/*                                                                         */
/* ======================================================================= */


/**
 * Allgemeine Anmerkungen zum Programm
 *
 * 
 */


import java.applet.*;   /* Importiert die Applet Klasse          */
import java.awt.*;      /* Importiert die GUI-Klassen            */
import java.util.*;     /* Systemutilities fuer String Tokenizer */


/* ======================================================================= */
/* Hauptklasse NetzProtokolle                                              */
/* ----------------------------------------------------------------------- */
/* Diese Klasse repraesenteirt das Applet und Startet das Fenster in dem   */
/* die Simulation ablaeuft.                                                */
/*                                                                         */
/* Einbindung in eine HTML Seite mit dem folgenden HTML Tag:               */   
/*                                                                         */
/* <APPLET CODEBASE= NetzProtokolle.class, Height=200, Width=400>          */
/* </APPLET>                                                               */
/*                                                                         */
/* ======================================================================= */

public class NetzProtokolle extends Applet implements Runnable {

    public ThreadGroup Animation; //= new ThreadGroup("Animation");
    private Thread dummy = null;
    
    public void init() {
        Fenster AppletWindow = new Fenster("Medium Access Control",this);
        Button btnWdh = new Button("Animation Wiederholen");
        this.add(btnWdh);
    }

    public void paint(Graphics g) {
        Font f=new Font("Times New Roman",Font.BOLD,20);
        g.setFont(f);
        g.drawString("Simulation von Netzzugangsprotokollen",10,70);
        f=new Font("Times New Roman",Font.PLAIN,12);
        g.setFont(f);
        g.drawString("Ein Applet zur Veranschaulichung von Zugangsprotokollen zu lokalen",10,100);
        g.drawString("Rechnernetzen",10,120);
        g.drawString("Studienarbeit fuer den Lehrstuhl PI4 der Universitaet Mannheim",10,140);
        g.drawString("Ersteller: Jochen Becher, 1997",10,160);
    }

    public boolean action (Event e, Object o) {
        if ("Animation Wiederholen".equals(o)) {

          Fenster AppletWindow = new Fenster("Medium Access Control",this);
        }
        return true;
    }
    
    public ThreadGroup getAnimation() {
    
        return Animation;
    }
    
    public void start() {
    
        if (dummy == null) {
        
            dummy = new Thread(this,"dummy");
            dummy.setPriority(1);
            Animation = dummy.getThreadGroup();
            Animation.setMaxPriority(1);
            /*System.out.println("Therad Group mit activeCount: "+Animation.activeCount()+" Thread(s)");*/
            /*System.out.println("Therad Group mit activeGroupCount: "+Animation.activeGroupCount()+" Thread(s)");*/
            dummy.start();
        }
    }
    
    public void run() {
    
        dummy.suspend();
    }

    public void stop() {
    
        if ((dummy != null) && dummy.isAlive()) {
        
            dummy.stop();
        }
        
        dummy = null;
        
        /* Netscpe Workaround */
        Thread thArray[];
        thArray = new Thread[Animation.activeCount()];
        int count = Animation.enumerate(thArray);
                
        /*Animation.list();*/
                
        for (int i = 0; i < count; i++) {
                
            if (thArray[i].getName().equals("dummy") == false) {

                if (thArray[i].getName().equals("Thread-1") == false) {
                    
                    /*System.out.println("VOR stop für: "+thArray[i].getName());*/
                    if ((thArray[i] != null) && (thArray[i].isAlive())) {
                    
                        thArray[i].stop();
                    }    
                    /*System.out.println("NACH stop für: "+thArray[i].getName());*/
                }
            }      
        }
        
        /* Beim Appletviewer ausreichender Aufruf, egal in welcher Klasse
        Animation.stop(); */
        
    }
    
    public void resume() {
    
        /* Netscpe Workaround */
        Thread thArray[];
        thArray = new Thread[Animation.activeCount()];
        int count = Animation.enumerate(thArray);
                
        /*Animation.list();*/
                
        for (int i = 0; i < count; i++) {
                
            if (thArray[i].getName().equals("dummy") == false) {

                if (thArray[i].getName().equals("Thread-1") == false) {
                    
                    /*System.out.println("VOR resume für: "+thArray[i].getName());*/
                    if ((thArray[i] != null) && (thArray[i].isAlive())) {
                    
                        thArray[i].resume();
                    }    
                    /*System.out.println("NACH resume für: "+thArray[i].getName());*/
                }
            }      
        }
        
        /* Beim Appletviewer ausreichender Aufruf, egal in welcher Klasse
        Animation.resume(); */
    }
    
    public void suspend() {
    
        /* Netscpe Workaround */
        Thread thArray[];
        thArray = new Thread[Animation.activeCount()];
        int count = Animation.enumerate(thArray);
                
        /*Animation.list();*/
                
        for (int i = 0; i < count; i++) {
                
            if (thArray[i].getName().equals("dummy") == false) {

                if (thArray[i].getName().equals("Thread-1") == false) {
                    
                    /*System.out.println("VOR suspend für: "+thArray[i].getName());*/
                    if ((thArray[i] != null) && (thArray[i].isAlive())) {
    
                        thArray[i].suspend();
                    }    
                    /*System.out.println("NACH suspend für: "+thArray[i].getName());*/
                }
            }      
        }
        
        /* Beim Appletviewer ausreichender Aufruf, egal in welcher Klasse
        Animation.suspend();*/
    }
    
}


/* ======================================================================= */
/* Klasse Fenster                                                          */
/* ----------------------------------------------------------------------- */
/* Stellt das Fenseter für die Animationen zur Verfügung                   */
/*                                                                         */
/* ======================================================================= */

class Fenster extends Frame {

    public int anzahlRechner = 0; /* Nimmt die Anzahl der dargest. Rechner */
                                  /* aus den Dialogen auf                  */
    public int Persistenz;        /* Infos zur Persistenz aus Dialog */                      
 
    public int sleepTime = 5;     /* Geschwindigkeitseinstellung */


    /* TextArea fuer Hinweise, Format 8 Zeilen, 2 Spalten */
    public TextArea HinweisTexte =new TextArea(6,1);

    /* Panels fuers Basislayout */
    Panel Hinweise =new Panel();
    Panel Zeichenbereich =new Panel();
    Panel Buttonleiste =new Panel();

    /* Buttons fuer die Leiste */
    Button btnStart = new Button("  start  ");
    Button btnHalt = new Button("  suspend  ");
    Button btnWeiter = new Button("  resume  ");
    Button btnStep = new Button("  step  ");
    Button btnStop = new Button("reset anim");
    Button btnFaster = new Button("  faster  ");
    Button btnSlower = new Button("  slower  ");
    Button btnHelp = new Button("   ?   ");
    Button btnClear = new Button("clear text");
    Button btn1Pers = new Button(" 1 pers. ");
    Button btn0Pers = new Button(" non pers. ");

    /* Container fuer die Animation*/
    Ethernet ethernet;
    TokenRing tokenRing;
    DQDB dqdb;

    private boolean activatedEthernet = false;
    private boolean activatedTokenRing = false;
    private boolean activatedDQDB = false;

    public NetzProtokolle netzProtokolle;

    /* Konstruktor */
    public Fenster(String Titel,NetzProtokolle nP) {

        setTitle(Titel);
        netzProtokolle = nP;

        /* Menueleiste erzeugen */
        MenuBar MainMenu = new MenuBar();

        Menu DateiMenu =new Menu("File");
        DateiMenu.add(new MenuItem("Speed"));
        DateiMenu.addSeparator();
        DateiMenu.add(new MenuItem("Close"));
        MainMenu.add(DateiMenu);

        /* alte Menuestruktur
        Menu ProtokolleMenu =new Menu("Protocols");
        ProtokolleMenu.add(new MenuItem("Ethernet"));
        ProtokolleMenu.addSeparator();
        ProtokolleMenu.add(new MenuItem("Token Ring"));
        ProtokolleMenu.add(new MenuItem("DQDB"));
        MainMenu.add(ProtokolleMenu);
        */
        
        Menu EthernetMenu = new Menu("Ethernet");
        EthernetMenu.add(new MenuItem("1 Persistent"));
        EthernetMenu.add(new MenuItem("Non Persistent"));
        MainMenu.add(EthernetMenu);
        
        Menu ExtrasMenu = new Menu("Animation");
        Menu _1Persistent = new Menu("1 Persistent");
        Menu _0Persistent = new Menu("Non Persistent");
        ExtrasMenu.add(_1Persistent);
        ExtrasMenu.add(_0Persistent);
        
        _1Persistent.add(new MenuItem("Normal transmission"));
        _1Persistent.add(new MenuItem("Transmission with collision"));
        _1Persistent.add(new MenuItem("Frame not long enough"));

        _0Persistent.add(new MenuItem("Normal transmission"));
        _0Persistent.add(new MenuItem("Transmission with collision"));
        _0Persistent.add(new MenuItem("Frame not long enough"));

        MainMenu.add(ExtrasMenu);

        Menu HilfeMenu = new Menu("Help");
        HilfeMenu.add(new MenuItem("How to"));
        HilfeMenu.addSeparator();
        HilfeMenu.add("Info");
        MainMenu.add(HilfeMenu);
        MainMenu.setHelpMenu(HilfeMenu); /* Hilfemenu ist rechts aussen ! */

        setMenuBar(MainMenu);
        /* Ende Menueleiste Erzeugen */

        /* Basislayout erzeugen */

        Zeichenbereich.setLayout(new GridLayout(1,1));
        Zeichenbereich.setBackground(Color.white);
        
        Buttonleiste.setLayout(new GridLayout(12,1));
        Buttonleiste.add(btnStart);
        Buttonleiste.add(btnHalt);
        btnWeiter.enable(true);
        Buttonleiste.add(btnWeiter);
        Buttonleiste.add(btnStep);
        btnStep.enable(false);
        Buttonleiste.add(btnStop);
        Buttonleiste.add(btnFaster);
        Buttonleiste.add(btnSlower);
        Buttonleiste.add(btnHelp);
        Buttonleiste.add(btnClear);
        Buttonleiste.add(btn0Pers);
        Buttonleiste.add(btn1Pers);

        setLayout(new BorderLayout());
        add("North",Hinweise);
        add("West",Buttonleiste);
        add("Center",Zeichenbereich);

        Hinweise.setLayout(new GridLayout(1,1));
        Hinweise.add(HinweisTexte);
        validate();

        pack();
        resize(640,540);
        move(5,5);
        show();

    }

    public boolean handleEvent (Event e) {
        
        if (e.id == Event.WINDOW_DESTROY) {
        
            /* Threads stoppen, falls sie laufen */
            /* netzProtokolle.Animation.stop();  */

            dispose();
        }
        
        if (e.id == Event.WINDOW_MOVED) {
        
        
            /*System.out.println("Moved aufgerufen");*/
        }
        
        return super.handleEvent(e);
    }

    public boolean action (Event e, Object o) {

        if (e.target instanceof MenuItem && "Close".equals(o)) {
     
            /* Threads stoppen, falls sie laufen*/
            /*netzProtokolle.Animation.stop();*/
            
            dispose(); /* fenster Schliessen */
        }

        if (e.target instanceof MenuItem && "Ethernet".equals(o)) {

            anzahlRechnerDialog Dlg = new anzahlRechnerDialog(this,"Ethernet",true);
        }

        if (e.target instanceof MenuItem && "Token Ring".equals(o)) {

            anzahlRechnerDialog Dlg = new anzahlRechnerDialog(this,"Token Ring",true);
        }

        if (e.target instanceof MenuItem && "DQDB".equals(o)) {

            dqdb = new DQDB(this);

            /*eventuell vorher vorhandene Animation Loeschen */
            Zeichenbereich.removeAll();

            Zeichenbereich.add(dqdb);
            Zeichenbereich.layout();

            activatedEthernet = false;
            activatedTokenRing = false;
            activatedDQDB = true;

            resize(size().width-1,size().height-1);
            resize(size().width+1,size().height+1);
        }
        
        if (e.target instanceof MenuItem && "Normal transmission".equals(o)) {
        
            stop();
            anzahlRechner = 5;
            
            if ( ((Menu) ((MenuItem) e.target).getParent()).getLabel().equals("1 Persistent") == true) {
            
                Persistenz = 1;
            }
            else {
            
                Persistenz = 0;
            }
                
            addEthernet();
            System.out.flush();
            ethernet.simulationVorbereiten(1);
            ethernet.setDemo(1);
            btnStart.enable(true);
        }

        if (e.target instanceof MenuItem && "Transmission with collision".equals(o)) {
        
            stop();
            anzahlRechner = 5;

            if ( ((Menu) ((MenuItem) e.target).getParent()).getLabel().equals("1 Persistent") == true) {
            
                Persistenz = 1;
            }
            else {
            
                Persistenz = 0;
            }

            addEthernet();
            System.out.flush();
            ethernet.simulationVorbereiten(2);
            ethernet.setDemo(2);
            btnStart.enable(true);
        }

        if (e.target instanceof MenuItem && "Frame not long enough".equals(o)) {
        
            stop();
            anzahlRechner = 5;

            if ( ((Menu) ((MenuItem) e.target).getParent()).getLabel().equals("1 Persistent") == true) {
            
                Persistenz = 1;
            }
            else {
            
                Persistenz = 0;
            }

            addEthernet();
            System.out.flush();
            ethernet.simulationVorbereiten(3);
            ethernet.setDemo(3);
            btnStart.enable(true);
        }

        if (e.target instanceof MenuItem && "Speed".equals(o)) {
        
            speedDialog sDlg = new speedDialog(this,"Animation speed",true);
        }

        if (e.target instanceof MenuItem && "How to".equals(o)) {
        
            hilfeDialog hilfeDialog = new hilfeDialog(this,"Help",true);
        }

        if (e.target instanceof MenuItem && "1 Persistent".equals(o)) {
        
            Persistenz = 1;
            anzahlRechnerDialog Dlg = new anzahlRechnerDialog(this,"Ethernet",true);
        }

        if (e.target instanceof MenuItem && "Non Persistent".equals(o)) {
        
            Persistenz = 0; 
            anzahlRechnerDialog Dlg = new anzahlRechnerDialog(this,"Ethernet",true);
        }

        if (("  start  ").equals(o)) {

             if (activatedEthernet == true) {

                 addHinweis("Start the transmission");
                 ethernet.senden();
                 btnStart.enable(false);
             }
             
             if (activatedTokenRing == true) {
             
                 addHinweis("Start der Token Ring Simulation gewählt");
                 tokenRing.Senden();
             }
             
             btnFaster.enable(false);
             btnSlower.enable(false);
             btn0Pers.enable(false);
             btn1Pers.enable(false);
        }
        
        if (("  suspend  ").equals(o)) {
        
            if (activatedEthernet == true) {
            
                addHinweis("Ethernet Simulation suspended, RESUME or STEP to continue");
                this.halt();
                btnStep.enable(true);
                btnHalt.enable(false);
                btnWeiter.enable(true);
            }
            
            if (activatedTokenRing == true) {
            
                addHinweis("Token Ring Simulation angehalten, weiter mit WEITER");
                this.halt();
                btnStep.enable(true);
                btnHalt.enable(true);
                btnWeiter.enable(true);
            }
        }

        if (("  resume  ").equals(o)) {
        
            if (activatedEthernet == true) {
            
                addHinweis("Ethernet simulation continued");
                this.weiter();
                btnStep.enable(false);
                btnHalt.enable(true);
                btnWeiter.enable(false);
            }
            
            if (activatedTokenRing == true) {
            
                addHinweis("Token Ring Simulation fortgesetzt");
                this.weiter();
                btnStep.enable(false);
                btnHalt.enable(true);
                btnWeiter.enable(false);
            }
        }

        if (("  step  ").equals(o)) {
        
            if (activatedEthernet == true) {
            
                addHinweis("Ethernet simulation in step-mode");
                this.stepMode();
            }
            
            if (activatedTokenRing == true) {
            
                addHinweis("Token Ring Simulation im Schritt für Schritt Modus");
                this.stepMode();
            }    
        }

        if (("reset anim").equals(o)) {
        
            if (activatedEthernet == true) {
            
                addHinweis("Ethernet simulation stopped");
                
                /* besser Threads hier einzeln anhalten 
                
                Thread thArray[];
                thArray = new Thread[netzProtokolle.Animation.activeCount()];
                int count = netzProtokolle.Animation.enumerate(thArray);
                
                netzProtokolle.Animation.list();
                
                for (int i = 0; i < count; i++) {
                
                    if (thArray[i].getName() != "dummy") {
                    
                        if (thArray[i].isAlive() == true) {
                        
                            System.out.println("VOR Stop für: "+thArray[i].getName());
                            thArray[i].stop();
                            System.out.println("NACH Stop für: "+thArray[i].getName());
                            try {
                    
                                thArray[i].join(5);
                            }
                            catch (InterruptedException exc) {
                    
                                System.out.println("Fehler bei stop Join");
                                thArray[i].dumpStack();
                            }    
                        }
                    }      
                    
                }
                */
                this.stop();
                
                addEthernet();  /* Neues Netz Erzeugen */
                
                btnFaster.enable(true);
                btnSlower.enable(true);
                btnStart.enable(true);
                btn0Pers.enable(true);
                btn1Pers.enable(true);
            }
        
            if (activatedTokenRing == true) {
        
                addHinweis("Token Ring Simulation abgebrochen"); 
                /* netzProtokolle.Animation.stop() */
                addTokenRing(); /* neues Netz Erzeugen */
            }
        
        }
        
        if (("  faster  ").equals(o)) {
        
            if (activatedEthernet == true) {
            
                if ((sleepTime > 1) == true) {
                    
                    this.sleepTime --;
                    addHinweis("Speeds up the simulation (- 1) / Current factor = "+sleepTime);
                    addHinweis("(less means faster)");
                }
                else {
                
                    addHinweis("factor = 1 is the fastest speed");
                }    
            }
        }    

        if (("  slower  ").equals(o)) {
        
            if (activatedEthernet == true) {
            
                this.sleepTime ++; 
                addHinweis("Slows down the simulation (+ 1) / Current factor ="+sleepTime);
                addHinweis("(less means faster)");
            }
        }
        
        if (("   ?   ").equals(o)) {
        
            if (activatedEthernet == true) {
            
                addHinweis("Choose any Workstations as sender or receiver of a Ethernet transmission");
                addHinweis("After that you can start the simulation by pressing the START Button");
                addHinweis("You can also select more than one pair, or first start the simulation and ");
                addHinweis("then select another pair and press START again to make them transmit, too."); 
                addHinweis("--------------------------------------------------------------------------------------");
            }
        }    
        
        if (("clear text").equals(o)) {
            
            HinweisTexte.setText("");
            System.out.flush();
        }
        
        if ((" 1 pers. ").equals(o)) {
        
            this.stop();
            Persistenz = 1;
            this.addEthernet();
            addHinweis("Ethernet set to 1 persistant");
        }

        if ((" non pers. ").equals(o)) {
        
            this.stop();
            Persistenz = 0;
            this.addEthernet();
            addHinweis("Ethernet set to non persistant");
        }


        return true;
    }


    public void addHinweis(String text) {

        HinweisTexte.appendText(text+" \n");
    }


    public void paint(Graphics g) {


    }
    
    public void addEthernet() {
    
            
        /*System.out.println("Anzahl :"+anzahlRechner);*/

        ethernet = new Ethernet(this,netzProtokolle);

        /*eventuell vorher vorhandene Animation Loeschen */
        Zeichenbereich.removeAll();

        Zeichenbereich.add(ethernet);
        Zeichenbereich.layout();

        activatedEthernet = true;
        activatedTokenRing = false;
        activatedDQDB = false;

        resize(size().width-1,size().height-1);
        resize(size().width+1,size().height+1);
        layout();
    
    }
    
    
    public void addTokenRing() {
    
        /*System.out.println("Anzahl :"+anzahlRechner);*/

        tokenRing = new TokenRing(this,netzProtokolle);

        /*eventuell vorher vorhandene Animation Loeschen */
        Zeichenbereich.removeAll();

        Zeichenbereich.add(tokenRing);
        Zeichenbereich.layout();

        activatedEthernet = false;
        activatedTokenRing = true;
        activatedDQDB = false;

        resize(size().width-1,size().height-1);
        resize(size().width+1,size().height+1);
        layout();
        
        addHinweis("Wählen Sie START um ein freies Token zu erzeugen,");
        addHinweis("danach wählen Sie eine Sende- und Empfangsstation und wieder START");
    }
   
    
    public void addDQDB() {
    
        dqdb = new DQDB(this);

        /*eventuell vorher vorhandene Animation Loeschen */
        Zeichenbereich.removeAll();

        Zeichenbereich.add(dqdb);
        Zeichenbereich.layout();

        activatedEthernet = false;
        activatedTokenRing = false;
        activatedDQDB = true;

        resize(size().width-1,size().height-1);
        resize(size().width+1,size().height+1);
        layout();
   
    }
    

    public void halt() {

        /*System.out.println("halt() aufgerufen");*/
        /*netzProtokolle.Animation.suspend(); */
        netzProtokolle.suspend();  
        /*System.out.println(netzProtokolle.Animation.activeCount());*/
    }


    public void stop() {

        /*System.out.println("stop() aufgerufen");*/
        /* Threads sollten einzeln angehalten werden */
        /*netzProtokolle.Animation.stop();*/
        netzProtokolle.stop();
        /*System.out.println(netzProtokolle.Animation.activeCount());*/
        
        if (activatedEthernet == true) {
         
            ethernet.setDemo(0);
            ethernet.setDemoMode(false);
        } 
    }


    public void weiter() {
    
        /*System.out.println("weiter() aufgerufen");*/
        /*netzProtokolle.Animation.resume();*/
        netzProtokolle.resume();    
        /*System.out.println(netzProtokolle.Animation.activeCount());*/
    }


    public void stepMode() {
    
        btnStep.enable(false);
        /*System.out.println("stepMode() aufgerufen");*/
        /*netzProtokolle.Animation.resume();*/
        netzProtokolle.resume();
        /*System.out.println("stepMode() hat resume aufgerufen");*/

        StepWait stepWait = new StepWait(netzProtokolle.Animation, sleepTime); 
        stepWait.setPriority(1);
        stepWait.start();
        
        /* Dieser Code Teil bremst das Programm sehr aus, spruenge entstehen
         * ist aber noetig, da eine verlagerung des Suspend in den Step Thread
         * einen Deadlock verursacht, weil der Thread sich dann selbst anhaelt
         * und mit sich das Programm */
        while ( stepWait.isAlive() ) {
        
        }
        
        /* stepWait.destroy();  */  
        /* geht nicht, da nicht in der ThreadGroup -> Sec. Exc.*/
        /* Garbage Collection  */
        /*System.gc();*/ 
            
        /* System.out.println("stepMode() ruft suspend auf"); */
        
        /*netzProtokolle.Animation.suspend();*/
        
        netzProtokolle.suspend();
        btnStep.enable(true);
            
    }
    
    public long getSleepTime() {
    
        return sleepTime;
    }
    
}


/* ======================================================================= */
/* Klasse MultiLineLabel                                                   */
/* ----------------------------------------------------------------------- */
/* Diese Klasse stellt ein Mehrzeiliges Label bereit.                      */   
/*                                                                         */
/* Es wird in den Dialogfenstern benutzt um dem Anwender zu zeigen, was    */
/* er tun soll.                                                            */
/* ======================================================================= */


class MultiLineLabel extends Canvas {


    String[] Inhalt;
    int Zeilen;
    Dimension dialogGr;   /* Groesse des aufrufenden Fensters */

    /* Konstruktor */
    public MultiLineLabel(String label,Dimension d) {

        dialogGr = d;

        /* String Tokenizer loest den String in die einzelnen Zeilen auf */
        /* das Erkennungstoken ist der Zeilenumbruch                     */

        StringTokenizer t = new StringTokenizer(label,"\n");

        Zeilen = t.countTokens();         /* Feld fuer die Zeilen */
        Inhalt = new String[Zeilen];      /* Anzahl der Zeilen   */

        /* Schreibt die Zeilen ins das Feld */

        /*System.out.println(Zeilen);*/
        for (int i=0; i < Zeilen;i++) {

            Inhalt[i] = t.nextToken();
            /*System.out.println(Inhalt[i]);*/
        }
        resize(dialogGr.width,((Zeilen+1)*20)+10);
    }


    public void paint(Graphics g) {

        for (int i=0; i < Zeilen;i++) {

            Font tempFont = new Font("Times",0,9);
            g.setFont(tempFont);

            g.drawRect(5,5,dialogGr.width-20,((Zeilen+1)*20));
            g.drawString(Inhalt[i],15,((i+1)*15)+5);
        }
    }
}


/* ======================================================================= */
/* Klasse anzahlRechnerDialog                                              */
/* ----------------------------------------------------------------------- */
/* Dialog zur Eingabe der Rechneranzahl                                    */
/*                                                                         */ 
/* ======================================================================= */

class anzahlRechnerDialog extends Dialog {


    String Art;  /* Ethernet oder Token Ring */
    Fenster f;
    Choice auswahlAnzahl = new Choice();
    CheckboxGroup persistenz;
    Checkbox[] checkboxes; 


    /* Konstruktor */
    public anzahlRechnerDialog(Fenster F, String Titel,boolean modal) {

        /* Erzeugt den Modalen Dialog                                   */
        /* Konstruktor der Superklasse Dialog von anzahletRechnerDialog */
        super(F,Titel,modal);

        f = F;
        setTitle(Titel);
        Art = Titel;

        Button btnOK = new Button("        Fertig        ");

        resize(150,250);

        MultiLineLabel Hinweis =
          new MultiLineLabel("Please select the\n"+
                             "number of Workstations",this.size());

        if ("Ethernet".equals(Art)) {

            for (int i=2; i<9; i++) {

                auswahlAnzahl.addItem(i+" Workstations");
            }
            
            /*Eingabe der Persistenz*/    
            persistenz = new CheckboxGroup();
            checkboxes = new Checkbox[2];
            checkboxes[0] = new Checkbox("Non Persistent",persistenz,false);
            checkboxes[1] = new Checkbox("1 Persistent (Def.)",persistenz,true);

            /* frueher wurde die Persistenz hier eingestellt
            setLayout(new FlowLayout(FlowLayout.CENTER,0,8));
            this.add(Hinweis);
            this.add(auswahlAnzahl);
            this.add(checkboxes[0]);
            this.add(checkboxes[1]);
            this.add(btnOK);
            */
            setLayout(new BorderLayout(3,1));
            this.add("North",Hinweis);
            this.add("Center",auswahlAnzahl);
            this.add("South",btnOK);
        }
        
        if ("Token Ring".equals(Art)) {
        
            auswahlAnzahl.addItem("4 Rechner");
            auswahlAnzahl.addItem("6 Rechner");
        
            setLayout(new BorderLayout(3,1));
            this.add("North",Hinweis);
            this.add("Center",auswahlAnzahl);
            this.add("South",btnOK);
        }
      
        pack();
        resize(150,260);
        move(200,150);
        System.out.flush();
        show();
    }


    public boolean action (Event e, Object o) {

        if ("        Fertig        ".equals(o)) {

            if ("Ethernet".equals(Art)) {

                f.anzahlRechner = auswahlAnzahl.getSelectedIndex() + 2;
                /*
                if (checkboxes[0].getState() == true) {
                
                    f.Persistenz = 0;
                }
                else  {
                
                    f.Persistenz = 1;
                }
                */
                
                /*System.out.println(Art);*/
                
                f.addEthernet();

            }

            if ("Token Ring".equals(Art)) {

                if (auswahlAnzahl.getSelectedIndex() == 0) {
                
                    f.anzahlRechner = 4;
                }
                if (auswahlAnzahl.getSelectedIndex() == 1) {
                
                    f.anzahlRechner = 6;
                }
                
                /*System.out.println(Art);*/
                
                f.addTokenRing();
            }
            
            if ("DQDB".equals(Art)) {
            
            
            }

            dispose();
       }

       return true;
    }
}

/* ======================================================================= */
/* Klasse speedDialog                                                      */
/* ----------------------------------------------------------------------- */
/*                                                                         */
/* ======================================================================= */

class speedDialog extends Dialog {

    private Fenster f;
    private Scrollbar anzeige;
    private Label label;
        
    public speedDialog(Fenster F, String Titel,boolean modal) {

        /* Erzeugt den Modalen Dialog                         */
        /* Konstruktor der Superklasse Dialog von speedDialog */
        super(F,Titel,modal);

        f = F;
        setTitle(Titel);

        Button btnOK = new Button("       OK       ");
        
        label = new Label("  Please choose the animation delay (in ms) : current: "+f.sleepTime);
        
        anzeige = new Scrollbar(0,f.sleepTime,1,0,250);
        
        resize(350,150);

        setLayout(new BorderLayout(3,1));
        this.add("North",label);
        this.add("Center",anzeige);
        this.add("South",btnOK);
      
        pack();
        resize(350,150);
        System.out.flush();
        /*System.out.println("vor show()");*/
        show();
    }

    public boolean action (Event e, Object o) {

        if ("       OK       ".equals(o)) {

            f.sleepTime = anzeige.getValue();      
            dispose();
        }
        
        label.setText(label.getText() + anzeige.getValue());
        repaint();
        /*this.add("North",label);*/
        System.out.flush();
        
        return true;
    }

}


/* ======================================================================= */
/* Klasse busDaten                                                         */
/* ----------------------------------------------------------------------- */
/* Dieser Thread aminiert das Senden der Daten ueber den Bus und initiiert */
/* die Kollissionserkennung                                                */
/*                                                                         */
/* ======================================================================= */

class busDaten extends Thread {

    private Bus bus;
    private Graphics g;
    private etRechner rechner;
    private Color Farbe;
    private long sleepTime;
    private NetzProtokolle np;

    /* 0 : links, 1 rechts */    
    public Koordinate paar = new Koordinate(0,0);
 
    /*
    busDaten(ThreadGroup tg,Bus b,int Y,Graphics gr) {

        bus = b;
        g = gr;
    }
    */

    busDaten(etRechner r,Ethernet et,Color farbe) {

        super(et.netzProtokolle.Animation ,"busDaten");
        bus = r.ethernet.bus;
        g = et.getGraphics();
        rechner = r;
        Farbe = farbe;
        sleepTime = rechner.ethernet.getSpeed();
        np = et.netzProtokolle; /* Applet */
    }


    private /* synchronized */  void istAnkerpunkt(int linksrechts,int x) {

         /* Auf Kollision pruefen */
         if (bus.Kollision == false) {
         
             if ((linksrechts == 0) && (Farbe != Color.gray)){
          
                 paar.x = x;
             }
         
             else paar.y = x;
          
             if ((paar.x != 0) && (paar.y != 0)) {
                       
                 if (bus.Belegung(paar.x,paar.y) == false) {
              
                     /*Kollisstion entdeckt*/
                     Farbe = Color.yellow;
                     rechner.ethernet.f.addHinweis("collision happend on the medium");
                 }
             }
         }
         else { /* Kollision wurde bereits erkannt */     
         
             /* Alle auf dem Bus Zeichnenden Threads auf Gelb setzen */
             if (Farbe != Color.yellow) {
             
                 Farbe = Color.yellow;
             }    
         }

         /* Ankerpunkt pruefen */
         for (int i=1; i < (bus.anzahletRechner+1); i++) {

             if (x == bus.anker[i]) {

                 /*System.out.println("Aufruf von anschlussDaten aus busDaten");*/
                 if (i != rechner.getRechnerNr()) {
                 
                        /* collision Detection */

                        if (rechner.ethernet.rechner[i].getSchritt().equals("Snd...") == true) { 
                            
                           /* Kollision entdeckt */
                           rechner.ethernet.rechner[i].setCD();
                        }

                        anschlussDaten an = new anschlussDaten(rechner.ethernet.rechner[i],1,Farbe);
                        an.setPriority(1);
                        an.start();

                 }
                 
                 if (i == 3) {
                  
                     bus.setDemo3Start(); 
                 }    
             }
         }
          
    }
    
             
    public /* synchronized */ void run() {

        boolean fertigLinks = false;
        boolean fertigRechts = false;

        try {

            System.out.flush();
            bus.aktiv = true;
            for (int i=0;i < (rechner.ethernet.busLaenge + 1);i++) {


                g.setColor(Farbe);

                /* ---- Bis zum rechten Rand ---- */
                if ((rechner.ethernet.busLaenge
                    - bus.anker[rechner.rechner_nr]
                    + bus.busStartx + 1) > i) {
                    
                    /* immer ganzes Rechteck vom anschluss an zeichnen 
                    g.fillRect(bus.anker[rechner.rechner_nr],
                               (int) (rechner.ethernet.busStart_y-(bus.busHoehe/2)),
                               i,
                               (int) (rechner.ethernet.busHoehe));
                    */           
                    /* Nur jeweils ein Pxel breite Striche Zeichnen (besser)*/
                    g.fillRect(bus.anker[rechner.rechner_nr] + i -1,
                               (int) (rechner.ethernet.busStart_y-(bus.busHoehe/2)),
                               1,
                               (int) (rechner.ethernet.busHoehe));
                               

                    istAnkerpunkt(1,(bus.anker[rechner.rechner_nr]+i));
                    
                }

                else { fertigRechts = true; }


                /* ---- Bis zum linken Rand ---- */
                if ((bus.anker[rechner.rechner_nr] - i) > (bus.busStartx -1)) {

                    /* immer ganzes Rechteck vom Anschluss an Zeichnen 
                    g.fillRect(bus.anker[rechner.rechner_nr]-i,
                               (int) (rechner.ethernet.busStart_y-(bus.busHoehe/2)),
                               i,
                               (int) (rechner.ethernet.busHoehe));
                    */           
                    /* nur jew. 1 Pixel breite Striche zeichen (besser)*/
                    g.fillRect(bus.anker[rechner.rechner_nr]-i,
                               (int) (rechner.ethernet.busStart_y-(bus.busHoehe/2)),
                               1,
                               (int) (rechner.ethernet.busHoehe));

                    istAnkerpunkt(0,(bus.anker[rechner.rechner_nr]-i));
                    
                }

                else { fertigLinks = true; }

                g.setColor(Color.black);
                this.sleep(sleepTime);

                if ((fertigLinks == true) & (fertigRechts == true)) {
                
                    break;
                }
            }
            
            /*test*/
            if (Farbe != Color.gray) {
            
                /*darf erst anfangen, wenn sicher ist, dass keine Kollision
                 *uebersehen werden kann .... d.h. Pakete duerfen nicht zu 
                 *kurz sein */
                
                /*System.out.println("DemoNummer "+rechner.ethernet.getDemoNr());*/
                /* folgendes Nicht, wenn Paket zu kurz sein soll */
                if (rechner.ethernet.getDemoNr() != 3) { 
                
                    /* warten bis Paket lange genug ist */
                    bus.aktiv = true;
                    /* die 2 sind zur Sicherheit da, da das Zeichnen auch Rechnezeit verbraucht */
                    this.sleep( (int) (sleepTime * bus.busLaenge * 2) );                    
                } 

                rechner.leeren(rechner.getSendeAn());
            }    

            if (Farbe != Color.red) {
            
                bus.aktiv = false;
                bus.setBelegtNull();
                /*System.out.println("setBelegtNull() aufgerufen");*/
                bus.Kollision = false;
            }    
            
                
        }
        catch (InterruptedException e) {

            /*System.out.println("Exception in busDaten.run()");*/
            bus.aktiv = false;
        }

    }
}


/* ======================================================================= */
/* Klasse anschlussDaten                                                   */
/* ----------------------------------------------------------------------- */
/*                                                                         */
/* ======================================================================= */

class anschlussDaten extends Thread {

    private etRechner rechner;
    private Graphics g;
    private Ethernet ethernet;
    private int status;                /* 0 : Senden, 1 : Empfangen */
    private Color Farbe;
    private long sleepTime;
    private NetzProtokolle np;

    anschlussDaten(etRechner r,int s,Color farbe) {

        super(r.ethernet.netzProtokolle.Animation,("anschlussDaten"+r.getRechnerNr()));
        rechner = r;
        g = rechner.gr;
        ethernet = r.ethernet;
        status = s;
        Farbe = farbe;
        sleepTime = ethernet.getSpeed();
        np = r.ethernet.netzProtokolle;

        /*System.out.println("anschlussdaten(etRechner: "+rechner.rechner_nr+" , Status: "+s+")");*/
    }

    public /* synchronized */ void run() {

        System.out.flush();

        try {

            if (status == 0) {  /* ---- Sende ---- */

                System.out.flush();
                
                if (Farbe == Color.red) {
                
                    rechner.setAktiv(true);
                    rechner.setSchritt("Snd...");
                }    
                else {
                    
                        /* Bus wird geleert */        
                        if (rechner.getZustand() == 3) {
                        
                            /* Rechner war Sender und empfaenger, wenn senden fertig ist, 
                             * muss er noch empfangen */
                            
                            if (((rechner.ethernet.rechner[rechner.getEmpfangeVon()].getZustand() % 2) == 1) &&
                                 (rechner.ethernet.rechner[rechner.getSendeAn()].getZustand() < 2))                           
                            {
                                rechner.setZustand(2);
                            }

                            if (((rechner.ethernet.rechner[rechner.getEmpfangeVon()].getZustand() % 2) != 1) &&
                                 (rechner.ethernet.rechner[rechner.getSendeAn()].getZustand() > 2))                           
                            {
                                rechner.setZustand(1);
                            }
                            
                        }
                        else {
                        
                            rechner.setZustand(0);
                        }    
                        rechner.setAktiv(false);
                }    
                    
                
                if ((rechner.rechner_nr % 2) == 1) {  /* Ungerader etRechner */

                    for (int i=1; i < (rechner.ethernet.abstand); i++) {/*rechner.H+1*/
      
                        g.setColor(Farbe);
                        g.fillRect((int) (rechner.X+rechner.W/2-rechner.ethernet.busHoehe/2),
                                   (int) (rechner.Y+rechner.H),
                                   (int) (rechner.ethernet.busHoehe),
                                   i);
                        g.setColor(Color.black);
                        this.sleep(sleepTime);
                    }

                }

                else {   /* ---- Gerader etRechner ---- */

                    for (int i=rechner.Y; i > (rechner.Y - rechner.ethernet.abstand); i--) {

                        g.setColor(Farbe);
                        g.fillRect((int) (rechner.X+rechner.W/2-rechner.ethernet.busHoehe/2),
                                   i,
                                   (int) (rechner.ethernet.busHoehe),
                                   (rechner.Y-i));
                        g.setColor(Color.black);
                        this.sleep(sleepTime);
                    }
                }

                ethernet.setbusAnimation(rechner.rechner_nr,Farbe);
                /*System.out.println("busAnimation aufgerufen");*/
                
            }


            else {  /* ---- Empfange ---- */

                rechner.setEmpfaengt(true);
                if (rechner.getZustand() >= 2) {
                    
                    if (ethernet.rechner[rechner.getEmpfangeVon()].getSchritt() == "Snd...") {
                    
                        rechner.setAktiv(true);
                        rechner.setSchritt("Rec...");
                    }
   
                }    

                System.out.flush();
                if ((rechner.rechner_nr % 2) == 1) {  /* ---- Ungerader etRechner ---- */

                    /*System.out.println("ungerader etRechner "+rechner.rechner_nr);*/
                    for (int i=1; i < (ethernet.abstand+1); i++) {

                        g.setColor(Farbe);
                        g.fillRect((int) (ethernet.bus.anker[rechner.rechner_nr]-ethernet.busHoehe/2),
                                   (int) (ethernet.busStart_y-i),
                                   (int) (ethernet.busHoehe),
                                   i);
                        g.setColor(Color.black);
                        this.sleep(sleepTime);
                    }

                }

                else {   /* ---- Gerader etRechner ---- */

                    /*System.out.println("gerader etRechner "+rechner.rechner_nr);*/
                    for (int i=1; i < (int) (rechner.ethernet.abstand); i++) {

                        g.setColor(Farbe);
                        g.fillRect((int) (rechner.X+rechner.W/2-rechner.ethernet.busHoehe/2),
                                   (int) (rechner.Y-rechner.ethernet.abstand),
                                   (int) (rechner.ethernet.busHoehe),
                                   i);
                        g.setColor(Color.black);
                        this.sleep(sleepTime);
                    }
                }

                if ((rechner.getZustand() >= 2 ) && (Farbe == Color.gray)) {
            
                    /*Rechner war Empfaenger*/
                    /*Pruefen ob er auch empfaenger dieser Uebertragung war, oder einer */
                    /*noch wartenden */
                    if (ethernet.rechner[rechner.getEmpfangeVon()].getZustand() == 0 )  {
                                        
                        rechner.setZustand(rechner.getZustand()-2);
                    }
                }
                
                if (Farbe == Color.gray) {
                
                    rechner.setEmpfaengt(false);
                    rechner.setSchritt("  ");
                    rechner.setAktiv(false);
                }
              
            }

            /* this.yield(); */
        }
        
        catch (InterruptedException e) {
     
            /*System.out.println("Exception in anschlussDaten.run()");*/
            System.out.flush();
        }

    }

}


/* ======================================================================= */
/* Klasse ContDown                                                         */
/* ----------------------------------------------------------------------- */
/* Count Down für die 0 Persistenten zugriff im Ethernet                   */
/* die Klasse ermittelt die Zufällige Wartezeit eines Rechners bevor er    */
/* nach belegtem Medium wieder sendet                                      */           
/* ======================================================================= */

class CountDown extends Thread {

    private etRechner rechner;
    private long sleepTime;
    private int warteIntervall = 100;
    private int Versuch; /* der wievielte Sendeveruch des Rechners bei belegtem medium */

    CountDown(ThreadGroup tg, etRechner r, long sleep) {
    
        super(tg,"CountDown"+r.getRechnerNr());
        rechner = r;
        sleepTime = sleep;
        Versuch = rechner.getSendeVersuch();
        warteIntervall = (int) (rechner.ethernet.busLaenge /* * 2 */ );
    }
    
    public void run() {
    
        /* Beim ersten Versuch zwischen 0 und 10    */
        /* Beim n-ten Versuch zwischen 0 und 10 * n */  
    
        int i = (int) (Math.random() * 10 * Versuch);
        
        for (int j = i; j > 0; j--) {
        
            rechner.setWaitTime(j);
            
            try {
            
                this.sleep(sleepTime * warteIntervall);
            }
            catch (InterruptedException e) {
            
                /*System.out.println("Fehler in CountDown.run");*/
            }    
        }

        rechner.setWaitTime(0);
    }
}


/* ======================================================================= */
/* Klasse CDWiederholung                                                   */
/* ----------------------------------------------------------------------- */
/* Count Down für die Wiederholung eines Zugriffs nach CD im Ethernet      */
/* die Klasse ermittelt aus der Anzahl der Kollisionen das Wartezeit-      */
/* fenster und wartet eine zufällige Zeit aus diesem Fenster               */           
/* ======================================================================= */

class CDWiederholung extends Thread {

    private etRechner rechner;
    private long sleepTime;
    private long anzahlWdh;

    CDWiederholung(ThreadGroup tg, etRechner r, long sleep, int anzahl) {
    
        super(tg,"CDWiederholung"+r.getRechnerNr());
        rechner = r;
        sleepTime = sleep;
        anzahlWdh = anzahl;
    }
     
    public void run() {
    
        try {
        
            rechner.setSchritt("CD");
            rechner.ethernet.f.addHinweis("CD at Workstation "+rechner.getRechnerNr()+ " wait for end of transmission");
            /*System.out.println(anzahlWdh);*/

            /* erst wenn der Bus frei ist ,
             * Warte 2 * BusLaenge * sleepTime .... brauche Mehr, wegen der Operationen
             * die Stattfinden, das uebrzeichnen braucht noch 2 Lanegen und eine
             * laenge zur Sicherheit, weil ja auch noch gezeichnet werden muss also 5 * BusLaenge 
             */
            this.sleep((rechner.ethernet.bus.busLaenge * 5 * sleepTime));
            
            /* 2 hoch #wdh -1  = obergrenze*/
            int waitFactor = (int) (Math.exp(anzahlWdh*(Math.log(2))))  -1; 
            rechner.ethernet.f.addHinweis("Collision No. "+anzahlWdh+" detected: Workstation "+rechner.getRechnerNr()+
                                          " waits random time slots between [0.."+waitFactor+"]");
            /* 2 hoch #wdh -1  = obergrenze*/
            waitFactor = (int) (Math.exp(anzahlWdh*(Math.log(2))))  -1; 
            /* Zufallsfaktor zwischen 0 und Obergrenze abziehen */
            waitFactor = waitFactor - (int) ((Math.random() * 10 * waitFactor) % (waitFactor + 1));
        
            for (int i = waitFactor; i > 0; i --) {       
        
                rechner.setCDWaitTime(i);
                /* Warteslot sollte einer anderen Station das vollstaendige Senden ermoeglichen */
                this.sleep(sleepTime * rechner.ethernet.bus.busLaenge * 5);
            }
            
            rechner.ethernet.f.addHinweis("Workstation "+rechner.getRechnerNr()+ " is repeating the transmission ");
            rechner.sendeWdh();    
        }
        
        catch (InterruptedException e) {
        
            /*System.out.println("Exception in CDWiederholung");*/
        }
    
    } 
     
}


/* ======================================================================= */
/* Klasse StepWait                                                         */
/* ----------------------------------------------------------------------- */
/* Wartezeit bis zum naechsten suspend im Step Mode                        */
/* ======================================================================= */

class StepWait extends Thread {

    private int stepWeite = 20;  /* Multiplikator fuer die SleepTime*/
    private int sleepTime = 5;
    private ThreadGroup animation;

    StepWait(ThreadGroup tg, int sleep) {
    
        super(tg,"StepWait");
        sleepTime = sleep;
        animation = tg;
    }
    
    public void run() {
    
        try {
        
            sleep( (sleepTime * stepWeite) );   
        }
        
        catch (InterruptedException e) {
        
            /*System.out.println("Exception in StepWait");*/
        }
    }
}


/* ======================================================================= */
/* Klasse animiereRechner                                                  */
/* ----------------------------------------------------------------------- */
/* Animiert den Rechner, der Aktiv ist, damit kien Langeweile aufkommt,    */
/* wenn das Paket bereitd den ganzen Bus belegt hat                        */
/* ======================================================================= */

class animiereRechner extends Thread {

    private long sleepTime = 5;
    private ThreadGroup animation;
    private Rechner rechner;
    private boolean weiter = true;

    animiereRechner(ThreadGroup tg, long sleep, Rechner r) {
    
        super(tg,"animiereRechner"+r.getRechnerNr());
        sleepTime = sleep;
        animation = tg;
        rechner = r;
    }
    
    public void run() {
    
        try {
        
            while (this.weiter == true) {
            
                for (int i = 1; i < 40 ; i++) {
            
                    rechner.gr.setColor(Color.red);
                    rechner.gr.fillRect((rechner.X+10 + i),rechner.Y+50,5,5);
                    rechner.gr.setColor(Color.white);
                    rechner.gr.fillRect((rechner.X+10 + i -1),rechner.Y+50,1,5);
                    rechner.gr.setColor(Color.black);
                    this.sleep(sleepTime);
                }
                for (int i = 1; i < 6 ; i++) {

                    rechner.gr.setColor(Color.white);
                    rechner.gr.fillRect((rechner.X+10 + i -2 + 40),rechner.Y+50,1,5);
                    rechner.gr.setColor(Color.black);
                    this.sleep(sleepTime);
                }
                
            }
            
            rechner.gr.setColor(Color.white);
            rechner.gr.fillRect((rechner.X+10),rechner.Y+50,45,5);

        }
        
        catch (InterruptedException e) {
        
            /*System.out.println("Exception in animiereRechner");*/
        }    
    }
    
    public void stoppen() {
    
        weiter = false;
    }
    
}


/* ======================================================================= */
/* Klasse demo3Wait                                                         */
/* ----------------------------------------------------------------------- */
/* Wartezeit bis zum naechsten suspend im Step Mode                        */
/* ======================================================================= */

class demo3Wait extends Thread {

    private long sleepTime = 5;
    private ThreadGroup animation;
    private Ethernet ethernet;

    demo3Wait(ThreadGroup tg, long sleep, Ethernet ether) {
    
        super(tg,"demo3Wait");
        sleepTime = sleep;
        animation = tg;
        ethernet = ether;
    }
    
    public void run() {
    
        try {
        
            while (ethernet.bus.getDemo3Start() == false) {
            
                sleep( sleepTime * 40 );   
            }
            
            ethernet.demo3Fortfuehren();    
        }
        
        catch (InterruptedException e) {
        
            /*System.out.println("Exception in demo3Wait");*/
        }    
    }
}


/* ======================================================================= */
/* Klasse anschlussCS                                                      */
/* ----------------------------------------------------------------------- */
/* Die Klasse fuehrt das Carrier Sensing durch und entscheidet ja nach     */
/* Bus Zustand und Persistenz ueber den Start des Sendevorgangs            */
/* Visualisiert wird dies durch zwei gelbe Striche am Rand des Anschlusses */   
/* ======================================================================= */

class anschlussCS extends Thread {

    private etRechner rechner;
    private Graphics g;
    private Ethernet ethernet;
    private int empfaenger;
    private long sleepTime;
    private NetzProtokolle netzProtokolle;

    anschlussCS(String Name,etRechner r, int empf,NetzProtokolle np) {

        super(np.Animation,"CS");
        /*System.out.println("Therad Group mit activeCount: "+np.Animation.activeCount()+" Thread(s)");*/
        /*System.out.println("Therad Group mit activeGroupCount: "+np.Animation.activeGroupCount()+" Thread(s)");*/

        netzProtokolle = np; 
        rechner = r;
        g = rechner.gr;
        ethernet = r.ethernet;
        empfaenger = empf;
        sleepTime = ethernet.getSpeed();
      
        /*System.out.println("anschlussCS(CS etRechner: "+rechner.rechner_nr);*/
    }


    public /* synchronized */ void run() {

        /*ethernet.ethernetAnimation.addThread(this);*/
        System.out.flush();
        rechner.setAktiv(true);
        rechner.addSendeVersuch();

        try {

            if ((rechner.rechner_nr % 2) == 1) {  /* Ungerader etRechner */
                 for (int i=1; i < (rechner.ethernet.abstand); i++) {
  
                    g.setColor(Color.orange);
                    g.fillRect((int) (rechner.X+rechner.W/2-rechner.ethernet.busHoehe/2),
                               (int) (rechner.Y+rechner.H),
                               3,
                               i);
                    g.fillRect((int) (rechner.X+rechner.W/2+rechner.ethernet.busHoehe/2-3),
                               (int) (rechner.Y+rechner.H),
                               3,
                               i);
                    g.setColor(Color.black);
                    this.sleep(sleepTime);
                 }

            }

            else {   /* ---- Gerader etRechner ---- */

                for (int i=rechner.Y; i > (rechner.Y - rechner.ethernet.abstand); i--) {

                    g.setColor(Color.orange);
                    g.fillRect((int) (rechner.X+rechner.W/2-rechner.ethernet.busHoehe/2),
                               i,
                               3,
                               (rechner.Y-i));
                    g.fillRect((int) (rechner.X+rechner.W/2+rechner.ethernet.busHoehe/2-3),
                               i,
                               3,
                               (rechner.Y-i));
                    g.setColor(Color.black);
                    this.sleep(sleepTime);
                }
            }

            /*System.out.println("CS fertig");*/

            /* Ueberpruefen, ob der Bus belegt ist, wenn nich dann senden
               aufrufen */
  
            if (ethernet.bus.aktiv == false) {
            
                /* Senden ohne Probleme */
                /* prüfen, ob nicht daten da sind */
                rechner.setSchritt(" ");
                System.out.flush();
                rechner.sende(empfaenger);
                System.out.flush();
            }  
            else {
                
                /* genauer nachschauen, ob der Bus hier noch frei ist */
                if (rechner.getEmpfaengt() == false) {
                
                    rechner.sende(empfaenger);
                    rechner.setSchritt(" ");
                }
                else {
                
                    /* nochmal aufrufen in Abhaengigkeit der Persistenz */
                    if (ethernet.Persistenz == 1) {
                        
                        rechner.setSchritt("CS");
                        while (ethernet.bus.aktiv == true) {
                    
                            /* Rechenzeit sparen, da das staendige nachschauen ausbremst */                
                            this.sleep(sleepTime * 50);
                            /*System.out.flush();*/
                        } 
                        ethernet.bus.setBelegtNull();
                        this.run();
                    }
                    if (ethernet.Persistenz == 0) {
                    
                        /* Anzahl der Sendeveruche beachten */
                        /* Count Down starten               */
                        
                        CountDown countDown = new CountDown(netzProtokolle.Animation,rechner,sleepTime);
                        countDown.setPriority(1);
                        countDown.start();
                        while (countDown.isAlive() == true) {
                        
                            /* Rechenzeit sparen, da das staendige nachschauen ausbremst */                
                            this.sleep(sleepTime * 50);
                            /* this.yield(); */
                        }
                        this.run();
                        ethernet.bus.setBelegtNull();                    
                    }             
                /* rechner.setAktiv(true); */    
                }    
            }    
                
            this.yield();
        }
        
        catch (InterruptedException e) {
     
            /*System.out.println("Exception in anschlussCS.run()");*/
        }

    }
}



/* ======================================================================= */
/* Klasse Bus                                                              */
/* ----------------------------------------------------------------------- */
/* Die Klasse Bus stellt Buselemente mit Funktionen bereit um einen Daten- */
/* strom zu simulieren                                                     */
/*                                                                         */
/* ======================================================================= */

class Bus extends Object {

    Graphics g;

    public int busStartx;
    public int busStarty;
    public int busLaenge;
    public int busHoehe;
    public int anzahletRechner;
    public boolean demo3Start = false; /* Punkt, an dem das Demo 3 wietergef. werden muss */
                                       /* um den gewuenschten effekt zu erzielen */  
    
    public boolean aktiv;
    private Koordinate belegt = new Koordinate(0,0);
    public boolean Kollision = false;

    public int[] anker = new int[9]; /* x-Werte der Anschluesse */


    Bus() {
    
        aktiv = false;
    }


    Bus(Ethernet ether,int x,int y,int laenge,int hoehe,int anzahl) {

        g = ether.getGraphics();
        busStartx = x;
        busStarty = y;
        busLaenge = laenge;
        busHoehe = hoehe;
        anzahletRechner = anzahl;
        aktiv = false;

        zeichne(g);
    }


    public void zeichne(Graphics g) {

        System.out.flush();
        g.setColor(Color.gray); 
        g.fillRect(busStartx,
                   busStarty-busHoehe/2,
                   busLaenge,
                   busHoehe);
        g.setColor(Color.black);
    }
    
    public /* synchronized */ boolean Belegung(int xLinks, int xRechts) {
    
        int altLinks = belegt.x;
        int altRechts = belegt.y;
        boolean erg = true;
        
        /*System.out.println("altLinks: "+altLinks+" altRechts: "+altRechts+" xLinks: "+xLinks+" xRechts: "+xRechts);*/
                
        if ((altLinks != 0) && (altRechts != 0)) {

            if ((altRechts > xRechts) | (altLinks < xLinks)) {
            
                /*Vergleichen, da paar von anderem Datentransport */
                
                if (altRechts < xLinks) {
                
                    /*     0--alt--0  0--neu--0 */      
                    erg = true;
                }       
                else {
                
                    if (altLinks > xRechts) {
                    
                        /*    0--neu--0    0--alt--0 */
                        erg = true;
                    }
                    else erg = false;
                }
            
            }

            if (erg == false) {
        
                Kollision = true;
                /*System.out.println("Kollision entdeckt");*/
            }
               
        }
        
        else {
        
            /*System.out.println("initialisiert "+xLinks+"  "+xRechts);*/
        }
        
        belegt.x = xLinks;
        belegt.y = xRechts;    
        return erg;    
    }

    public void setBelegtNull() {
    
        belegt.x = 0;
        belegt.y = 0;
    }
    
    public boolean getDemo3Start() {
    
        /* Startpunkt fuer die zweite Uebertragung beim Demo3 */
        return demo3Start;
    }
    
    public void setDemo3Start() {
        
        /* Setzt den Startpunkt uer die zweite Uebertragung beim Demo3 */
        demo3Start = true;
    }
}


/* ======================================================================= */
/* Klasse Anschluss                                                        */
/* ----------------------------------------------------------------------- */
/* Die Klasse Anschluss stellt ein Buselement dar, mit den speziellen      */
/* Methoden, die ein Buselement, das direkt an einen etRechner gekopelt ist  */
/* braucht (z.B. Carrier Sensing)                                          */
/*                                                                         */
/* ======================================================================= */

class Anschluss extends Bus {

    public Ethernet ethernet;
    public int fueretRechner;
    public int X;
    public int Y;


    Anschluss(Ethernet ether,Bus bus,int x,int y,int rechner) {

        ethernet = ether;
        fueretRechner = rechner;
        X=x; Y=y;

        zeichne(bus.g);
    }


    public void zeichne(Graphics g) {

        System.out.flush();
        g.setColor(Color.gray); 
        switch (fueretRechner % 2) {

            case 0 : g.fillRect((int) (X + (ethernet.breiteetRechner/2) - ethernet.busHoehe/2),
                                (int) (Y - ethernet.abstand),
                                (int) ethernet.busHoehe,
                                (int) ethernet.abstand);
                                break;

            case 1 : g.fillRect((int) (X + (ethernet.breiteetRechner/2) - (ethernet.busHoehe/2)),
                                (int) (Y + ethernet.hoeheetRechner),
                                (int) ethernet.busHoehe,
                                (int) ethernet.abstand);
                                break;
        }
        g.setColor(Color.black);
    }

}


/* ======================================================================= */
/* Klasse Rechner                                                          */
/* ----------------------------------------------------------------------- */
/* Stellt einen Prototyp fuer Rechner dar                                  */
/*                                                                         */
/* Der Rechner hat die Zustaende (Idle, Send, Rec., Send/Rec.)             */
/*                                                                         */
/* Methoden zum setzen und Auswerten sind:                                 */
/* - public void setZustend(int neuerZustand)                              */
/* - public int getZustand()                                               */
/* - public String getZustendAsString()                                    */
/*                                                                         */
/*   wobei gilt:      0 : Idle (tut nichts)                                */
/*                    1 : Sender                                           */
/*                    2 : Empfaenger                                       */
/*                    3 : Sender und Empfaenger                            */
/*                                                                         */
/* - public String Schritt                                                 */
/*                                                                         */
/*                                                                         */
/* ======================================================================= */

class Rechner extends Object {

    public Graphics gr;
    public int X; int Y; int H; int W;
    public int rechner_nr;

    private int Zustand;     /* Zustand des Rechners */
    private String Schritt = " ";
    private boolean aktiv = false;  /* Der Rechner sendet oder versucht es */
    
    private int sendeAn;
    private int empfangeVon;
    
    public Canvas Protokoll;

    public ThreadGroup Animation;

    Rechner(Canvas protokoll,int x, int y, int w, int h, int r_nr) {

       gr = protokoll.getGraphics();
       Protokoll = protokoll;
       X = x; Y = y; H = h; W = w;
       rechner_nr = r_nr;
       Zustand = 0;
       Schritt = " ";

       zeichne(gr);
    }


    public void zeichne(Graphics gr) {

       gr.drawRect(X+6,Y+2,W-12,H-20);                /* Monitor aussen */
       gr.setColor(Color.white);
       gr.fillRect(X+8,Y+6,W-16,H-28);
       gr.fillRect(X+2,Y+H-16,W-4,15);                /* Zentraleinheit uebermalen */
       gr.setColor(Color.black);
       gr.drawRect(X+8,Y+6,W-16,H-28);                /* Monitor innen  */
       gr.drawRect(X+2,Y+H-16,W-4,15);                /* Zentraleinheit */
       gr.drawRect(X+W-21,Y+H-12,15,4);               /* Laufwerk       */

       gr.setColor(Color.red);
       gr.drawString(""+rechner_nr,X+8,Y+H-4);        /* Rechnernummer  */
       gr.drawString(getZustandAsString(),X+10,Y+18); /* Zustand        */
       gr.drawString(getSchrittAsString(),X+10,Y+42); /* Schritt        */

       switch (Zustand) {

           case 1  : if (sendeAn == 0) {

                         gr.drawString("to: ?",X+10,Y+30); 
                     }
                     else {

                         gr.drawString("to: "+sendeAn,X+10,Y+30); 
                     }
                     break;
                     
           case 2  : gr.drawString("from: "+empfangeVon,X+10,Y+30); break;
           
           case 3  : gr.drawString("to: "+sendeAn+"/fr.: "+empfangeVon,X+10,Y+30);
       }

       if (aktiv == true) {
       
           gr.setColor(Color.green);
           gr.fillOval(X+22,Y+H-12,8,8);
           gr.setColor(Color.black);
           gr.drawOval(X+22,Y+H-12,8,8);
       }

       gr.setColor(Color.black);
       System.out.flush();
       
       zeichneWeiter(gr);  /* Methode um in den abgeleiteten Klassen noch weitere */
                           /* Sachen auf den Bildschirm zu zeichnen */ 
       
    }

    public void zeichneWeiter(Graphics g) {
    
        /* Diese Methode ist in den abgeleiteten Klassen ausprogrammiert */
    }


    public boolean istInBereich(int co_x, int co_y) {

        /*System.out.println(co_x+","+co_y);*/
        /*System.out.println(X+","+Y+","+W+","+H);*/

        if (co_x > X) {

           /*System.out.println(co_x+" > "+X);*/
           if (co_x < (X+W)) {

                /*System.out.println(co_x+" < "+(X+W));*/
                if (co_y > Y) {

                    /*System.out.println(co_y+" > "+Y);*/
                    if (co_y < (Y+H)) {

                        /*System.out.println(co_y+" < "+(Y-H));*/
                        return true;
                    }
                    else return false;
                }
                else return false;
            }
            else return false;
        }
        else return false;
    }


    public void setZustand(int neuerZustand) {

       Zustand = neuerZustand;
       if (neuerZustand == 0) {
           
           this.setSchritt(" "); 
       }
       zeichne(gr);
    }
    
    public void setZustandDirekt(int neuerZustand) {
    
        /* wenn diese Methode benutzt wird, muessen alle anderen Schritte in
         * der aufrufenden Methode selbst Programmiert werden , ansonsten setZustand
         * benutzen */
        Zustand = neuerZustand;
    }

    public void setSendeAn(int An) {

        sendeAn = An;
    }

    
    public int getSendeAn() {
    
        return sendeAn;
    }


    public void setempfangeVon(int Von) {

        empfangeVon = Von;
    }

    
    public int getZustand() {

        return Zustand;
    }


    public String getZustandAsString() {

       switch (Zustand) {

           case 0  : return "Idle"; 
           case 1  : return "Send"; 
           case 2  : return "Receive";
           case 3  : return "Snd/Rec.";
           default : return "Error";
       }
    }

    public String getSchrittAsString() {
    
        return Schritt;
    }

    public int getEmpfaenger() {

        return sendeAn;    
    }
    
    public int getEmpfangeVon() {
    
        return empfangeVon;
    }

    public void setSchritt(String str) {
    
        Schritt = str;
        this.zeichne(gr);
    }
    
    public String getSchritt() {
    
        return Schritt;
    }
    
    public int getRechnerNr() {
    
        return rechner_nr;
    }

    public void setAktiv(boolean akt) {
    
        if (akt != aktiv) {
        
            aktiv = akt;
            /*System.out.println("Aktiviert: "+akt);*/
            zeichne(gr);
            if (akt == true) {
          
                rechnerAnimationStart();
                zeichne(gr);
            }
            else {
        
                rechnerAnimationStop();    
                zeichne(gr);
            }
        }    
    }

    public boolean getAktiv() {
    
        return aktiv;
    }
    
    public void rechnerAnimationStart() {
    
        /* in den einzelnen Protokollen ausgefuehrt */
    }
    
    public void rechnerAnimationStop() {
    
        /* in den einzelnen Protokollen ausgefuehrt */
    }
}


/* ======================================================================= */
/* Klasse etRechner                                                        */
/* ----------------------------------------------------------------------- */
/* Stellt einen Ethernet Rechner dar                                       */
/* Implementiert spezifische Funktionen für das Ethernet Protokoll (senden */
/* empfangen, CarrierSensing collision detection                          */
/* ======================================================================= */

class etRechner extends Rechner {

    public Ethernet ethernet;
    private int sendeVersuche = 0;
    private boolean empfaengt = false;
    private boolean collision = false;
    private int colCount = 0; /* Anzahl der Kollisionen */

    private int waitTime;  /* Zeit, bis der 0 Persitente wartende Rechner wieder sendet */
    private animiereRechner animRechner; /* Animationsthread fuer den Rechner waehred
                                          * der Aktiv Phase */  

    etRechner(Ethernet ether,int x, int y, int w, int h, int r_nr) {

        super(ether,x,y,w,h,r_nr);
        ethernet = ether;
    }

    
    public void zeichneWeiter(Graphics g) {
    
        /*Eigene Zeichenroutinen, die nur fuer etRechner gelten */
    }
 
 
    public void sende(int empfaenger) {

        anschlussDaten an = new anschlussDaten(this,0,Color.red);
        an.setPriority(1);
        super.setAktiv(true);
        an.start();
        /* .... jetzt in die Methode leeren kopiert ....
         * da diee Warteschleifen daran schuld waren, dass die Animation
         * zu sehr gestockt hat. Leeren wird nun am ende vom BusDaten Thread
         * aufgerufen wenn der Bus wieder ueberzeichnet wurde. Ausserdem ist 
         * die explizite Leeren Methode auch für die zu kurzen Pakete wichtig 
         ***********
        while (an.isAlive() == true) { 
            
            System.out.flush();
        } 
        System.out.println("sende prueft busAniamtion");
        while (ethernet.busAnimation.isAlive() == true) {
        
            System.out.flush();
        } 
        
        System.out.println("vor Threaderzeugung");
        an = new anschlussDaten(this,0,Color.gray);
        an.setPriority(1);
        an.start();
        System.out.flush();
        setZustand(0);
        zeichne(gr);
        while (an.isAlive() == true) { System.out.flush(); }
        this.setAktiv(false);
        */
    }

    public void leeren(int empfaenger) {
    
        /* Kommentar siehe in etRechner.Sende() */
        /*System.out.println("vor Threaderzeugung");*/
        anschlussDaten an = new anschlussDaten(this,0,Color.gray);
        an.setPriority(1);
        an.start();
        System.out.flush();
        setZustand(0);
        zeichne(gr);
        super.setAktiv(false);
        if (this.getSchritt().equals("CD") == false) {
            
            colCount = 0; /* Rechner fertig Kollision kann nicht mehr festgestellt  */
                          /* werden, also Zähler für diesen Rechner auf Null stellen */   
        }                  
    }

    public void empfange(int sender) {

       anschlussDaten von = new anschlussDaten(this,1,Color.red);
       von.setPriority(1);
       super.setAktiv(true);
       von.start();
    }


    public void carrierSensing(int empfaenger) {

       NetzProtokolle np = ethernet.netzProtokolle;
       anschlussCS cs = new anschlussCS("CS",this,empfaenger,np);
       setSchritt("CS");
       super.setAktiv(true);
       cs.setPriority(1);
       cs.start();
    }

    public void addSendeVersuch() {
    
        sendeVersuche = sendeVersuche + 1;
    }
    
    public int getSendeVersuch() {
    
        return sendeVersuche;
    }
    
    public void setSendeVersuchNull() {
    
        sendeVersuche = 0;
    }
    
    public void setEmpfaengt(boolean status) {
    
        empfaengt = status;
    }
    
    public boolean getEmpfaengt() {
    
        return empfaengt;
    }

    public void setWaitTime(int i) {
    
        this.waitTime = i;   
        this.setSchritt("Wait .."+i);
    }
    
    public int getWaitTime() {
    
        return this.waitTime;
    }

    public void setCD() {   
        
        /* collision Detection setzten, wird von Bus Daten gemacht, wenn die */  
        /* AnschlussDaten gestartet werden und der Rechner gerade sendet      */

        collision = true;
        /*System.out.println("CD am Rechner aufgerufen");*/
        this.setSchritt("CD");  /* Rechner hat die Kollision erkannt */
        colCount ++;            /* Kollision zaehlen */
        
        ethernet.f.addHinweis("collision detected at workstation: "+getRechnerNr()); 
        /* Sendewiederholung nach Algorithmus initiieren */
        /* Wartethread starten */
        CDWiederholung warte = new CDWiederholung(ethernet.f.netzProtokolle.Animation,
                                                  this,
                                                  ethernet.getSpeed(),
                                                  colCount);
        warte.setPriority(1);
        warte.start();
    }

    public void setCDWaitTime(int i) {
    
        this.waitTime = i;   
        this.setSchritt("wait.. "+i);
    }
    
    public void sendeWdh() {
    
        carrierSensing(this.getEmpfaenger());
    }

    public void setZustand(int neuerZustand) {

       /* Ethernet spezifisches setZustand, ueberschreibt das SetZustand aus
        * rechner */
       boolean isDrei = (getZustand() == 3); /* Station ist Sender und Empf.*/
       
       super.setZustandDirekt(neuerZustand);
       if (neuerZustand == 0) {
           
           if (this.getSchritt().equals("CD") == false) {
           
               setSchritt(" "); 
           }
           else {
              
               /* verbleibt im Sendezustand */
               if (isDrei == true) {
               
                   super.setZustand(3);
               }
               else {
               
                   super.setZustand(1);
               }    
           }    
           zeichne(gr);
       }

    }
    
    public void rechnerAnimationStart() {
    
        animRechner = new animiereRechner(ethernet.f.netzProtokolle.Animation,
                                          ethernet.getSpeed(),    
        		                               this);
        animRechner.setPriority(1);
        animRechner.start();								                                 
    }
    
    public void rechnerAnimationStop() {
    
        /* anim rechner wird zu ende Ausgefuehrt */    
        animRechner.stoppen();
        zeichne(gr);
    }
}


/* ======================================================================= */
/* Klasse Koordinate                                                       */
/* ----------------------------------------------------------------------- */
/* Die Klasse Koordinate ist die Datenstruktur fuer eine x,y Koordinate    */
/*                                                                         */
/* ======================================================================= */

class Koordinate extends Object {

   int x;      /* x - Wert der Koordinate */
   int y;      /* y - Wert der Koordinate */

   Koordinate(int X, int Y) {

       x = X;
       y = Y;
   }
}


/* ======================================================================= */
/* Klasse Ethernet                                                         */
/* ----------------------------------------------------------------------- */
/* Die Klasse stellt die Zeichenflaeche fuer die Ethernet Simulation       */ 
/* bereit und zeichnet das Netz mit n Rechnern                             */
/*                                                                         */
/* ======================================================================= */

class Ethernet extends Canvas {

    public int anzahl;
    public Fenster f;
    public boolean init;            /* Konstruieren der etRechner in paint */

    public int Persistenz  = 1;

    private boolean mausClick;
    private int     xpos;
    private int     ypos;
    
    private boolean demoMode = false; /* Demosimulationen */
    private int demo = 0;             /* welches Demo laeuft ab */;

    public etRechner[] rechner = new etRechner[9];
    private Anschluss[] anschluss = new Anschluss[9];
    public Bus bus;

    /* Simulationszustaende */
    public boolean needSender;      /* noch kein Sender gewhlt    */
    public boolean needEmpfaenger;  /* noch kein Enpfaenger gewaehlt */
    public boolean needNeutral;
    
    public Koordinate sePaar = new Koordinate(0,0);  /* Sende Empfangspaar */

    public busDaten busAnimation;
    
    public NetzProtokolle netzProtokolle;

    /*---------------------------- Massse ---------------------------------- */

    /* Ende des Busses */
    public float busLaenge     = 550;

    /* Abstand des etRechners vom BUS (Mitte) (60) */
    public float abstand       = 60;

    /* Hoehe des etRechners (gesamt) Default 60 fuer max 8 rechner bei 640x480 */
    public float hoeheetRechner  = 80;

    /* Breite des etRechners */
    public float breiteetRechner = (float) (hoeheetRechner * 0.86);

    /* Anfang des Busses x-Wert */
    public float busStart_x    = 20;

    /* Anfang des Busses y-Wert */
    public float busStart_y    = 180;  /* default 160*/

    /* hoehe des Busses */
    public float busHoehe      = busLaenge/40;

    /*-------------------------------------------------------------------- */

    Koordinate Groesse = new Koordinate(0,0);

    /* Konstruktor */
    Ethernet(Fenster F,NetzProtokolle nP) {

        /*System.out.println("Konstruktor Ethernet aufgerufen");*/
        /*System.out.println("Size: w: "+size().width+" h: "+size().height);*/
        f = F;
        anzahl = f.anzahlRechner;
        init = true;
        needSender = true;
        needEmpfaenger = false;
        needNeutral = false;
        Persistenz = f.Persistenz;
        
        netzProtokolle = nP;
        
        elementeErzeugen(); 
        
        f.addHinweis("Choose any pair of Workstations as sender and receiver of a Ethernet transmission");
        f.addHinweis("You can also select more than one pair");
        f.addHinweis("To start the simulation press the START Button");

        repaint();
    }


    public void elementeErzeugen() {
    
    
    }
    

    public Koordinate locatexy(int nr) {

        float busSchnitt = busLaenge * ((float) nr/(float) (anzahl + 1)) + busStart_x;
        float start_x = busSchnitt - (breiteetRechner /2);
        float start_y = 0;

        /* oben ungerade unten gerade etRechnernr. */
        switch (nr % 2) {
           case 0 : start_y = busStart_y + abstand; break;
           case 1 : start_y = busStart_y - abstand - hoeheetRechner; break;

        }

        Koordinate erg = new Koordinate( (int) start_x,
                                         (int) start_y );

        return erg;
    }


    public void paint(Graphics g) {

        System.out.flush();
        if (Groesse.x != this.size().width) {
        
            init = true;
            Groesse.x = this.size().width;
        }
        
        if (Groesse.y != this.size().height) {
        
            init = true;
            Groesse.y = this.size().width;
        } 

        busStart_y = (int) (this.size().height / 2);
        busLaenge  = this.size().width - 35; 
        busHoehe      = busLaenge/40;

        Font old = g.getFont();
        Font f = new Font("Times New Roman",Font.BOLD+Font.ITALIC,16);
        g.setFont(f);
        g.setColor(Color.gray);
        g.drawString("IEEE 802.3 CSMA/CD (Ethernet) with "+anzahl+" workstations",20,20);
        g.setColor(Color.black);
        g.drawString("IEEE 802.3 CSMA/CD (Ethernet) with "+anzahl+" workstations",19,19);
        g.setFont(old);

        /* g.drawLine(10,50,f.size().width-100,50); */

        if (mausClick = true) {

            /* g.drawString("x Pos: "+xpos+"  y Pos: "+ypos,20,50); */
            mausClick = false;
        }

        if (init == true) {

            /*System.out.println("Neues Netz erzeugt");*/

            bus = new Bus(this,
                          (int) busStart_x,
                          (int) busStart_y,
                          (int) busLaenge,
                          (int) busHoehe,
                          anzahl);

            for(int i = 1;i < (anzahl+1);i++) {

                /* etRechner erzeugen */
                rechner[i] = new etRechner(this,
                                         locatexy(i).x,
                                         locatexy(i).y,
                                         (int) breiteetRechner,
                                         (int) hoeheetRechner,
                                         i);

                /* Anschluss erzeugen */
                anschluss[i] = new Anschluss(this,
                                             bus,
                                             (int) (locatexy(i).x),
                                             (int) (locatexy(i).y),
                                             i);

                /* Ankerpunkte fuer den Bus merken */
                bus.anker[i] = (int) (locatexy(i).x + (breiteetRechner/2));
    
            }

            init = false;
            
            if (demoMode == true) {
            
               demoKonfigurieren();
            } 
             
        }

        System.out.flush();
        /* Bus zeichnen */
        bus.zeichne(g);

        System.out.flush(); 
        /* Anschluesse zeichnen */
        for(int i = 1;i < (anzahl+1);i++) {

            anschluss[i].zeichne(g);
        }

        System.out.flush();
        /* etRechner zeichen */
        for(int i = 1;i < (anzahl+1);i++) {

            rechner[i].zeichne(g);
        }

    }


    public int selectedetRechner(int x, int y) {

        /* Die Funktion gibt an, ob der aktuelle Click auf einem der
           etRechner stettgefunden hat, wenn ja ist der Rueckgabewert dir
           Nummer des Rechners, wenn nein, 0
         */

        for(int i = 1;i < (anzahl+1);i++) {

            if (rechner[i].istInBereich(x,y) == true) {

                return i;
            }
        }

        return 0;
    }


    public boolean mouseDown(Event e, int x, int y) {

       mausClick = true;
       xpos = x;
       ypos = y;

       int sel = selectedetRechner(x,y);
       /*System.out.println("Ausgewaehlt: (x,y) = ("+x+","+y+") Nr.: "+sel);*/

       if (sel > 0) {

           if (needSender == true) {

               if (rechner[sel].getZustand() == 2 ) {
               
                   /* ist beides*/
                   rechner[sel].setZustand(3);
               }
               else {
               
                   rechner[sel].setZustand(1);
               }    
               f.addHinweis("Workstation: "+sel+" is sender, please select a receiver");
               sePaar.x = sel;
               needSender = false;
               needEmpfaenger = true;
               needNeutral = false;
           }
           else {
           
               if (needEmpfaenger == true) {
          
                   if (rechner[sel].getZustand() == 1) {
                   
                       /* ist beides*/
                       rechner[sel].setZustand(3);
                   }
                   else {
                   
                       rechner[sel].setZustand(2);
                   }    
                   f.addHinweis("Workstation: "+sel+" is receiver, you can start the simulation now");
                   sePaar.y = sel;
                   needEmpfaenger = false;
                   needSender = false;
                   needNeutral = true;

                   /* Uebertragung der Paare an die etRechner */
                   rechner[sePaar.x].setSendeAn(sePaar.y);
                   rechner[sePaar.y].setempfangeVon(sePaar.x);
                   
                   /* Start Button kann gedrueckt werden */
                   f.btnStart.enable(true);
               }
               
               else {
           
                   if (needNeutral == true) {
               
                       /*Rechner wird Neutral */
                       if (rechner[sel].getZustand() == 0) {
                       
                           /*Nichts tun, da Rechner sowieso Idle, daher Sender Wahrsch. */
                           needSender = true;
                           needEmpfaenger = false;
                           needNeutral = false;
                           mouseDown(e,x,y);
                       }
                       else {
                       
                           rechner[sel].setZustand(0);
                           f.addHinweis("Workstation: "+sel+" is idle");
                           needSender = true;
               					    needEmpfaenger = false;
               					    needNeutral = false;
               					}    
           					}
           			}		       
   					}

           System.out.flush();
           
           /*repaint();*/ 
           if (sel > 0) {
           
               rechner[sel].zeichne(this.getGraphics()); /*besser als repaint*/
               
               if (rechner[sel].getZustand() > 2) {
               
                   /*Sender aktualisieren, wenn Rechner empfaenger war */
                   System.out.flush();
                   rechner[rechner[sel].getEmpfangeVon()].zeichne(this.getGraphics());
                   System.out.flush();
               }  
           }

       }

       return true;
    }


    public void senden() {

        /* Rausfinden, wer an wen senden soll ! und die Vorgaenge nach
           Protokoll initiieren
        !  Merken wer an wen gesandet hat, und eventuell noch eine Wiederholung
           initiieren
        */
        
        for (int i=1; i < (anzahl + 1); i++) {

            /* Pruefen, ob rechner vielleicht schon sendet */ 
            if (((rechner[i].getZustand()% 2) == 1) & (rechner[i].getSchritt().equals(" ") == true)) {

                rechner[i].carrierSensing(rechner[i].getEmpfaenger());
                
            }
            for (int j=1 ; j < 10; j++) {}
        }
        
       
        if (demo == 3) { /* bei demo3 muss noch ein Zeitversetztes zweites senden erfolgen */
            
            if (demoMode == true) { /* sonst zweiter aufruf von senden in demo3 ! */
            
                /*demo3Fortfuehren();*/
                rechner[5].setZustand(1);
                rechner[5].setSendeAn(4);
                rechner[4].setZustand(2);
                rechner[4].setempfangeVon(5);
                /* Thread der den Bus prueft starten */
                demo3Wait d3Wait = new demo3Wait(f.netzProtokolle.Animation,
                                                 getSpeed(),
                                                 this);
                d3Wait.setPriority(1);
                d3Wait.start();
            }
        }
    }


    public void setbusAnimation(int R,Color farbe) {

        bus.aktiv = true;
        busAnimation = new busDaten(rechner[R],this,farbe);
        busAnimation.setPriority(1);
        busAnimation.start();
    }
    
    public long getSpeed() { 
    
        return f.getSleepTime();
    }
    
    public void simulationVorbereiten(int was) {
    
        /* Demos:
         * 1 : Normales Senden
         * 2 : Normales Senden mit Kollision
         * 3 : Rahmen zu kurz
         */  
        
        demoMode = true;
        demo = was;
        
        if (was == 1) {
        
            /* normale Datenuebertragung */
            f.HinweisTexte.setText(" ");            
            f.addHinweis("The simulation will be set up ...");
            f.addHinweis("Select START to see a normal transmission from (1) to (4)"); 
        }
        
        if (was == 2) {
        
            /* Datebuebertragung mit Kollision */
            f.HinweisTexte.setText(" ");            
            f.addHinweis("The simulation will be set up ...");
            f.addHinweis("Select START to see a transmission with a collision");
            f.addHinweis("(1) sends to (2), (5) sends to (4)");
        } 

        if (was == 3) {
        
            /* Zu Kurzer rahmen wird gesendet, so dass die Station 1 eine Kollision
             * übersieht
             * */
            f.HinweisTexte.setText(" ");            
            f.addHinweis("The simulation will be set up ...");
            f.addHinweis("Select START to start the animation");
            f.addHinweis("First (1) will send data to (2)");
            f.addHinweis("Before the data will reach (5), (5) itself sends data to (4)");
            f.addHinweis("(1) will stop sending data (and so will stop CD), before it can detect the collision ");
        }
        
        System.out.flush();
        
    }
    
    public void demoKonfigurieren() {
    
        if (demo == 1) {
        
            /* normale Uebertragung */
            rechner[1].setZustand(1);
            rechner[1].setSendeAn(4);
            rechner[4].setZustand(2);
            rechner[4].setempfangeVon(1);
        }    
        
        if (demo == 2) {
        
            /* normale Kollision */
            rechner[1].setZustand(1);
            rechner[1].setSendeAn(2);
            rechner[2].setZustand(2);
            rechner[2].setempfangeVon(1);
            rechner[5].setZustand(1);
            rechner[5].setSendeAn(4);
            rechner[4].setZustand(2);
            rechner[4].setempfangeVon(5);
        }

        if (demo == 3) {
        
            /* rahmen zu kurz */
            rechner[1].setZustand(1);
            rechner[1].setSendeAn(2);
            rechner[2].setZustand(2);
            rechner[2].setempfangeVon(1);
        }
        
        System.out.flush();
    }
    
    public void demo3Fortfuehren() {
   
        demoMode = false;  
        senden();
    }
     
    public boolean getDemoMode() {
    
        return demoMode;
    }
    
    public int getDemoNr() {
    
        return demo;
    }
    
    public void setDemo(int nr) {
    
        demo = nr;
    }
    
    public void setDemoMode(boolean temp) {
    
        demoMode = temp;
    }
}


/* ======================================================================= */
/* Klasse Ring                                                             */
/* ----------------------------------------------------------------------- */
/* Die Klasse Ring stellt einen Ring dar                                   */
/*                                                                         */
/* ======================================================================= */

class Ring extends Object {

    Graphics g;

    public TokenRing tokenRing;
    
    public int ringX;
    public int iringX;
    public int ringY;
    public int iringY;
    public int ringWeite;
    public int ringHoehe;
    public int abstandIr;
    public int anzahletRechner;
    public boolean aktiv;

    public double[] anker = new double[9]; /* Winkel der Rechner */


    Ring() {
    
        aktiv = false;
    }


    Ring(TokenRing tr,int x,int y,int durchmesser,int abstandInnenring,int anzahl) {

        g = tr.getGraphics();
        tokenRing = tr;
        ringX = x;
        ringY = y;
        ringWeite = durchmesser;
        ringHoehe = durchmesser;
        abstandIr = abstandInnenring;
        anzahletRechner = anzahl;
        iringX = (int) (ringX + (abstandIr / 2) );
        iringY = (int) (ringY + (abstandIr / 2) );

        zeichne(g);
    }


    public Koordinate anschluss(int i) {
    
        /* Berechnet die Position fuer den Bobbel */
        Koordinate MP = new Koordinate(tokenRing.startx + (int) (tokenRing.durchmesser/2) - 8,
                                       tokenRing.starty + (int) (tokenRing.durchmesser/2) - 8);
        Koordinate temp = new Koordinate(0,0);
        int radius = (int) (tokenRing.durchmesser / 2); radius = radius + 4;
        temp.x = (int) (MP.x - radius * Math.cos(Math.PI/2 + anker[i]) );
        temp.y = (int) (MP.y - radius * Math.sin(Math.PI/2 + anker[i]) );
        return temp; 
    }


    public void zeichne(Graphics g) {

        System.out.flush();
        g.setColor(Color.gray);
        g.fillOval(ringX,ringY,ringWeite,ringHoehe);
        g.setColor(Color.white);
        g.fillOval(iringX,iringY,ringWeite - abstandIr ,ringHoehe - abstandIr);
        
        /*Nur wenn die anker bereits initialisiert sind, anschluesse zeichnen*/
        if ((anker[1] != 0.0) && (anker[2] != 0.0)) { 
        
            /* Anschluesse */
            if (tokenRing.anzahl == 6) {
        
                for (int i = 1; i < 7 ; i ++) {
            
                    g.setColor(Color.gray);
                    g.fillOval(anschluss(i).x,anschluss(i).y,16,16);
                    g.setColor(Color.black);
                }      
            }
            else {
                
                for (int i = 1; i < 5 ; i ++) {
            
                    g.setColor(Color.gray);
                    g.fillOval(anschluss(i).x,anschluss(i).y,16,16);
                    g.setColor(Color.black);
                }    
            }
            System.out.flush();
        }        
    }


    public int getAnker(double testWert) {
    
        /* Gibt 0 zurueck, wenn es sich bei dem Winkel um keinen anker handelt, */
        /* ansonsten die Nummer des Rechners, dessen Anker gematcht wurde */  
   
        boolean erg = false;
        int index = 0;
        
        for (int i = 1; i <9 ; i++) {
        
            if (erg == false) {
            
                if ( ((int) (testWert * 100)) == ((int) (anker[i] * 100)) ) {
            
                    erg = true;
                    index = i;
                    /*System.out.println("Anker gefunden fuer Rechner "+i);*/    
                }
                else {
                
                }
            }    
        }
        return index;
    }
}


/* ======================================================================= */
/* Klasse Token Ring                                                       */
/* ----------------------------------------------------------------------- */
/* Die Klasse stellt die Zeichenflaeche fuer die TokenRing Simulation be-  */
/* reit und zeichnet das Netz mit n Rechnern                               */
/*                                                                         */
/* ======================================================================= */

class TokenRing extends Canvas {

    public int anzahl;
    public Fenster f;
    public boolean init; /* neues Netz erzeugen */
    
    public int[] sendeWuensche = new int[20];
    public int anzSendeWuensche = 0;

    public Koordinate Groesse = new Koordinate(0,0);
    
    public Ring ring;
    public trRechner[] rechner = new trRechner[9];
    
    public Koordinate sePaar = new Koordinate(0,0);  /* Sende Empfangspaar */

    /* Hoehe des etRechners (gesamt) Default 60 fuer max 8 rechner bei 640x480 */
    public float hoehetrRechner  = 90;
    /* Breite des etRechners */
    public float breitetrRechner = (float) (hoehetrRechner * 0.86);
   
    public NetzProtokolle netzProtokolle;
   
    /* Ringgeometrie */
    public int startx = 165;         /* x-Koordinate der linken oberen Ecke (140)*/
    public int starty = 30;          /* y-Koordinate der linken oberen Ecke */
    public int abstandIr = 32;       /*abstand des Innenrings vom aussenringdurchmesser*/
    public int durchmesser = 280;    /* Durchmesser des aussenrings  280*/     
    public int radiusLocator = (int) durchmesser / 2;  /* Radius des Locator Rings    -60  */

    public int tokenDia = 16;
    public int tokenRad = 0;

    /* Simulationszustaende */
    private boolean needSender = true;       /* noch kein Sender gewaehlt     */
    private boolean needEmpfaenger = false;  /* noch kein Enpfaenger gewaehlt */
    private boolean needNeutral = false;

    private boolean freiesToken = false;  /* Ist ein freies Token vorhanden */

    TokenRing(Fenster F, NetzProtokolle np) {

        f = F;
        anzahl = f.anzahlRechner;
        init = true;
        netzProtokolle = np;
    }


    public Koordinate locatexy(int nr) {
  
        Koordinate erg = new Koordinate(1,1);
        
        Koordinate KreisMP = new Koordinate(startx + (int) (durchmesser/2),
                                            starty + (int) (durchmesser/2));
        
        /* Berechne moegliche Koordinatenpunkte */
        
        /* Oben Rechts */
        Koordinate OR = new Koordinate
            (KreisMP.x + (int) ( (Math.cos(Math.PI/6) * radiusLocator) )
            ,KreisMP.y - (int) ( (Math.sin(Math.PI/6) * radiusLocator)));
        /* Unten Rechts */
        Koordinate UR = new Koordinate 
            (KreisMP.x + (int) ( (Math.cos(Math.PI/6) * radiusLocator) )
            ,KreisMP.y + (int) ( (Math.sin(Math.PI/6) * radiusLocator)));
        /* Unten Links */
        Koordinate UL = new Koordinate
            (KreisMP.x - (int) ( (Math.cos(Math.PI/6) * radiusLocator) )
            ,KreisMP.y + (int) ( (Math.sin(Math.PI/6) * radiusLocator))); 
        /* Oben Links */
        Koordinate OL = new Koordinate
            (KreisMP.x - (int) ( (Math.cos(Math.PI/6) * radiusLocator) )
            ,KreisMP.y - (int) ( (Math.sin(Math.PI/6) * radiusLocator)));
        
        if (anzahl == 4) {
        
            if (nr == 1) {erg.x = OR.x; erg.y = OR.y;}
            if (nr == 2) {erg.x = UR.x; erg.y = UR.y;}
            if (nr == 3) {erg.x = UL.x; erg.y = UL.y;}
            if (nr == 4) {erg.x = OL.x; erg.y = OL.y;}
        }
                                            
        if (anzahl == 6) {
        
            /* Mitte rechts */
            Koordinate MR = new Koordinate(KreisMP.x + radiusLocator,KreisMP.y); 
            /* Mitte links */
            Koordinate ML = new Koordinate(KreisMP.x - radiusLocator,KreisMP.y); 

            if (nr == 1) {erg.x = OR.x; erg.y = OR.y;}
            if (nr == 2) {erg.x = MR.x; erg.y = MR.y;}
            if (nr == 3) {erg.x = UR.x; erg.y = UR.y;}
            if (nr == 4) {erg.x = UL.x; erg.y = UL.y;}
            if (nr == 5) {erg.x = ML.x; erg.y = ML.y;}
            if (nr == 6) {erg.x = OL.x; erg.y = OL.y;}
        }                                                

        return erg;
    }

    public int selectedetRechner(int x, int y) {

        /* Die Funktion gibt an, ob der aktuelle Click auf einem der
           etRechner stettgefunden hat, wenn ja ist der Rueckgabewert dir
           Nummer des Rechners, wenn nein, 0
         */

        for(int i = 1;i < (anzahl+1);i++) {

            if (rechner[i].istInBereich(x,y) == true) {

                return i;
            }
        }

        return 0;
    }


    public boolean mouseDown(Event e, int x, int y) {

        int sel = selectedetRechner(x,y);
        /*System.out.println("Ausgewaehlt: (x,y) = ("+x+","+y+") Nr.: "+sel);*/

        System.out.flush();
 
        if (sel > 0) {

            if (needSender == true) {

                rechner[sel].setZustand(1);
                f.addHinweis("Rechner: "+sel+" ist Sender");
                sePaar.x = sel;
                needSender = false;
                needEmpfaenger = true;
                needNeutral = false;
            }
            else {
           
                if (needEmpfaenger == true) {
          
                    rechner[sel].setZustand(2);
                    f.addHinweis("Rechner: "+sel+" ist Empfaenger");
                    sePaar.y = sel;
                    needEmpfaenger = false;
                    needSender = false;
                    needNeutral = true;

                    /* Uebertragung der Paare an die etRechner */
                    rechner[sePaar.x].setSendeAn(sePaar.y);
                    rechner[sePaar.y].setempfangeVon(sePaar.x);
                }
               
                else {
           
                    if (needNeutral == true) {
               
                        /*Rechner wird Neutral */
                        if (rechner[sel].getZustand() == 0) {
                       
                            /*Nichts tun, da Rechner sowieso Idle, daher Sender Wahrsch. */
                            needSender = true;
                            needEmpfaenger = false;
                            needNeutral = false;
                            mouseDown(e,x,y);
                        }
                        else {
                        
                            rechner[sel].setZustand(0);
                            f.addHinweis("Rechner: "+sel+" ist Idle");
                            needSender = true;
                					   needEmpfaenger = false;
                					   needNeutral = false;
                 					   rechner[sel].setWillToken(false);
               					 }    
           		 			}
           	 		}		       
   					}
           
           rechner[sel].zeichne(this.getGraphics()); /*besser alss repaint*/
               
           if (rechner[sel].getZustand() >= 2) {
               
               /*Sender aktualisieren, wenn Rechner empfaenger war */
               System.out.flush();
               rechner[rechner[sel].getEmpfangeVon()].zeichne(this.getGraphics());
               System.out.flush();
           }
		

        } /* ENDE if (sel > 0) */
 
 
        return true;
    }


    public void paint(Graphics g) {

        if (Groesse.x != this.size().width) {
        
            init = true;
            Groesse.x = this.size().width;
        }
        
        if (Groesse.y != this.size().height) {
        
            init = true;
            Groesse.y = this.size().width;
        } 
        
        /*System.out.println("Token Ring Canvas W: "+this.size().width+" H: "+this.size().height);*/
        
        durchmesser = (int) ((this.size().width - 50) / 2);
        radiusLocator = durchmesser/2 + 70;
        startx = (int) (this.size().width / 2 - (durchmesser / 2)) ;
        starty = (int) ((this.size().height+20) / 2 - (durchmesser / 2));
        
        
        Font old = g.getFont();
        Font f = new Font("Times New Roman",Font.BOLD+Font.ITALIC,16);
        g.setFont(f);
        g.setColor(Color.gray);
        g.drawString("IEEE 802.5 Token-Ring mit "+anzahl+" Rechnern",20,20);
        g.setColor(Color.black);
        g.drawString("IEEE 802.5 Token-Ring mit "+anzahl+" Rechnern",19,19);
        g.setFont(old);


        /* ring fuer Locator
        g.setColor(Color.black);
        g.drawOval(60,-50,440,440);*/

        if (init == true) {

             /*System.out.println("Neues Netz erzeugt");*/

             ring = new Ring(this,startx,starty,durchmesser,abstandIr,anzahl);

             for(int i = 1;i < (anzahl+1);i++) {

                  /* trRechner erzeugen */
                  rechner[i] = new trRechner(this,
                                              locatexy(i).x - (int) hoehetrRechner/2,
                                              locatexy(i).y - (int) hoehetrRechner/2,
                                              (int) breitetrRechner,
                                              (int) hoehetrRechner,
                                              i);
                  
                  /* Ankerwinkel fuer den Ring merken */
                  if (anzahl == 4) {
                  
                      if (i < 3) {
                      
                          rechner[i].setStartWinkel( (i * 2 * Math.PI/6) );
                          ring.anker[i] = rechner[i].getStartWinkel();            
                      }
                      else {
                      
                          rechner[i].setStartWinkel( ((i-2) * 2 * Math.PI/6 + Math.PI) );
                          ring.anker[i] = rechner[i].getStartWinkel();
                      }                
                  }
                  if (anzahl == 6) {
                  
                      if (i < 4) {
                      
                          rechner[i].setStartWinkel( i * Math.PI/6 + Math.PI/6);
                          ring.anker[i] = rechner[i].getStartWinkel();            
                      }
                      else {

                          rechner[i].setStartWinkel( (i-3) * Math.PI/6 + Math.PI/6 + Math.PI);
                          ring.anker[i] = rechner[i].getStartWinkel();            
                      }   
                  }    
              }
              
              ring.zeichne(this.getGraphics());
              
              init = false;
        }

    }
    
    
    public int getAnzSendeWuensche() {
    
        return anzSendeWuensche;
    }
    


    public void tokenStarten(int i) {
    
        freiesToken = true;
        Token token = new Token(this.getGraphics(),this,rechner[i]);
        token.setPriority(1);
        token.start();
    }

    
    public void Senden() {
    
        if (freiesToken == false) {
        
            f.addHinweis("Ein freies Token wird am Rechner 1 gestartet");
            tokenStarten(1);
        }
        else {
        
            /* Senden initiieren */
            for (int i = 1; i < anzahl+1; i++) {
            
              if ((rechner[i].getZustand() % 2) == 1) {
              
                  rechner[i].tokenReservieren();
                  rechner[i].setWillToken(true);
              }  
            }  
        }
        
    }

    
    public void setFreiesTokenExistiert(boolean temp) {
    
        freiesToken = true;
    }


    public boolean getFreiesTokenExistiert() {
    
        return freiesToken;
    }
    
    
    public long getSpeed() {
    
        return f.sleepTime;
    }
}


/* ======================================================================= */
/* Klasse trRechner                                                        */
/* ----------------------------------------------------------------------- */
/* Die Klasse stellt die Rechner mit dem Token Ring Protokoll bereit       */
/*                                                                         */
/* ======================================================================= */

class trRechner extends Rechner {

    private TokenRing tokenRing;
    private double startWinkel; 
    private boolean hatToken = false;
    private boolean willToken = false;

    trRechner(TokenRing tr,int x, int y, int w, int h, int r_nr) {

        super(tr,x,y,w,h,r_nr);
        tokenRing = tr;
    }
 
 
    public void zeichneWeiter(Graphics g) {
    
        /* Eigene Zeichenroutinen, die nur fuer trRechner gelten */
        /*System.out.println("Zeichenroutine in TRRechner");*/   
        
        /* Token Zeichnen wenn es der Rechner hat */
        if (hatToken == true) {
        
            /* Token auf den Bildschirm zeichnen */
            g.setColor(Color.yellow);
            g.fillOval(super.X+50,Y+50,15,15); 
            g.setColor(Color.black);
            g.drawOval(super.X+50,Y+50,15,15); 
            System.out.flush();
        }
    }
 

    public void sende() {
    
        /*System.out.println("Sendevorgang beginnt");*/
        RingDaten ringDatenS = new RingDaten(tokenRing.netzProtokolle,
                                             tokenRing,
                                             rechner_nr,
                                             getSendeAn(),
                                             startWinkel,
                                             Color.red);
        ringDatenS.setPriority(1);
        ringDatenS.start();
        
        /* Laenge des Datenpaketes */
        while (tokenRing.rechner[getSendeAn()].getAktiv() == false) {
        
            System.out.flush();
        }

        /*System.out.println("Bus leeren");*/
        RingDaten ringDatenE = new RingDaten(tokenRing.netzProtokolle,
                                             tokenRing,
                                             rechner_nr,
                                             getSendeAn(),
                                             startWinkel,
                                             Color.gray);
        ringDatenE.setPriority(1);
        ringDatenE.start();
        
        this.setAktiv(false);
        
        while (ringDatenE.isAlive() == true) {
            
            System.out.flush();
        }
        
        tokenFreigeben();
    }    
    
    
    public void empfange(int von, Color c) {
    
        if (c == Color.red) {
        
            this.setSchritt("Rec...");
            this.setAktiv(true);
        }
        else {
        
            this.setZustand(0);
            this.setSchritt(" ");
            this.setAktiv(false);
        }
    }
    
    public void tokenReservieren() {
    
        this.setSchritt("Wait...");
        setWillToken(true);
    }
    
    public void tokenFreigeben() {
    
        willToken = false;
        hatToken = false;
        tokenRing.setFreiesTokenExistiert(true);
        this.setZustand(0);
        setSchritt(" ");
        tokenRing.tokenStarten(rechner_nr);   
    }
    
    public double getStartWinkel() {
    
        return startWinkel;
    }
    
    public void setStartWinkel(double winkel) {
    
        startWinkel = winkel;
    }
    
    public boolean getWillToken() {
    
        return willToken;
    }
    
    public void setWillToken(boolean s) {
    
        willToken = s;
    }
    
    public void setHatToken() {
    
        hatToken = true;
        this.setSchritt("Send...");
        this.setAktiv(true);
        sende();
    }

}    


/* ======================================================================= */
/* Klasse Token                                                            */
/* ----------------------------------------------------------------------- */
/*                                                                         */
/* ======================================================================= */

class Token extends Thread {

    public Graphics gr;
    TokenRing tr;
    private boolean nochmal = true;
    private double startWinkel = 0;
    private int tokenDia = 16;
    private int tokenRad = 0;


    Token(Graphics g, TokenRing prot, trRechner Startrechner) {
    
        super(prot.netzProtokolle.Animation,"Token");
        gr = g;
        tr = prot;
        tokenDia = prot.tokenDia;
        tokenRad = (int) (tokenDia /2);
        startWinkel = Startrechner.getStartWinkel();
    }
    
    public Koordinate KrKo(double winkel, double beginn) {
    
        Koordinate temp = new Koordinate(0,0);

        double radius = tr.durchmesser / 2 - tokenRad;    
        double Xm = tr.startx + (tr.durchmesser/2) - tokenRad;
        double Ym = tr.starty + (tr.durchmesser/2) - tokenRad;
    
        temp.x = (int) (Xm - radius * Math.cos(Math.PI/2 + beginn + winkel) );
        temp.y = (int) (Ym - radius * Math.sin(Math.PI/2 + beginn + winkel) );
    
        return temp;
    }
   
    public void run() {
    
        /* x0 Berechnen */
        int x0 = tr.startx + (int) (tr.durchmesser/2) - tokenRad;
        int y0 = tr.starty + (int) (tr.durchmesser/2) - tokenRad;
        
        Koordinate temp = new Koordinate(0,0);
        
        do {
        
            try {
            
               for (double winkel = 0; winkel < (2 * Math.PI); winkel += (Math.PI / 90) ) { 
               
                   temp = KrKo(winkel,startWinkel);
                   gr.setColor(Color.yellow);
                   gr.fillOval(temp.x,temp.y,tokenDia,tokenDia);
                   gr.setColor(Color.gray);
                   System.out.flush();
                   /*gr.fillOval(temp.x+2,temp.y+2,10,10);*/
                   sleep(tr.getSpeed());
                   gr.fillOval(temp.x,temp.y,tokenDia,tokenDia);
                   
                   /* Nachschauen, ob an Ankerpunkt */
                   if (tr.ring.getAnker(winkel+startWinkel) != 0){
                   
                       if (tr.rechner[tr.ring.getAnker(winkel+startWinkel)].getWillToken() == true) {
                       
                           /*System.out.println("Rechner bekommt Token zugeteilt");*/
                           tr.rechner[tr.ring.getAnker(winkel+startWinkel)].setHatToken();
                           tr.setFreiesTokenExistiert(false);
                           nochmal = false;
                           break;
                       }   
                   }
                   
               }    
    
            }

            catch (InterruptedException e) {
       
                /*System.out.println("Exception in Token.run()");*/
                System.out.flush();
            }
        
        } 
        while (nochmal == true);       
    }
    
    
    public void setStartWinkel(double winkel) {
    
        startWinkel = winkel;
    }
    
}

/* ======================================================================= */
/* Klasse RingDaten                                                        */
/* ----------------------------------------------------------------------- */
/*                                                                         */
/* ======================================================================= */

class RingDaten extends Thread {

    public Graphics gr;
    
    private double startWinkel; /* StartWinkel des Datentransfers*/
    private int von;            /* Startrechner */
    private int an;             /* Zielrechner  */     
    private TokenRing tr;
    private Color Farbe;
    private int tokenRad;
    private int tokenDia;
    private boolean nochmal = true;
    
    public RingDaten(NetzProtokolle np, TokenRing prot,int v, int a, double Winkel,Color farbe) {
    
        super(np.Animation,"RingDaten");
        von = v;
        an = a;
        startWinkel = Winkel;      
        tr = prot;
        Farbe = farbe;
        tokenDia = prot.tokenDia;
        tokenRad = (int) (tokenDia / 2);
        gr = prot.getGraphics();
    }

    public Koordinate KrKo(double winkel, double beginn) {
    
        Koordinate temp = new Koordinate(0,0);

        double radius = tr.durchmesser / 2 - tokenRad;    
        double Xm = tr.startx + (tr.durchmesser/2) - tokenRad;
        double Ym = tr.starty + (tr.durchmesser/2) - tokenRad;
    
        temp.x = (int) (Xm - radius * Math.cos(Math.PI / 2 + beginn + winkel) );
        temp.y = (int) (Ym - radius * Math.sin(Math.PI / 2 + beginn + winkel) );
    
        return temp;
    }

    public void run() {

        try {
            
            tr.ring.aktiv = true;
            /*System.out.println("Datenübertragung von: "+von+" an: "+an);*/
            
           for (double winkel = 0; winkel < (2 * Math.PI); winkel += (Math.PI / 90) ) { 
            
                gr.setColor(Farbe);
                gr.fillOval(KrKo(winkel,startWinkel).x,
                            KrKo(winkel,startWinkel).y,
                            tokenDia,
                            tokenDia);
                System.out.flush();
                sleep(tr.getSpeed());
                System.out.flush();
                   
                /* Nachschauen, ob an Ankerpunkt */
                if (tr.ring.getAnker(winkel+startWinkel) != 0) {
                   
                    if (tr.ring.getAnker(winkel+startWinkel) == an) {
                       
                        /*System.out.println("Empfänger erreicht");*/
                        tr.rechner[tr.ring.getAnker(winkel+startWinkel)].empfange(von, Farbe);
                        nochmal = false;
                    }   
                }
            }
            
            tr.ring.aktiv = false;
        }
        catch (InterruptedException e) {
   
            /*System.out.println("Exception in Token.run()");*/
            System.out.flush();
        }
    }

}



/* ======================================================================= */
/* Klasse DQDB                                                             */
/* ----------------------------------------------------------------------- */
/* Die Klasse stellt die Zeichenflche fr die DQDB Simulation bereit      */
/* und zeichnet das Netz mit 2 Ringen                                      */
/*                                                                         */
/* ======================================================================= */

class DQDB extends Canvas {

  public Fenster f;


  DQDB(Fenster F) {

    f = F;
  }


  public void paint(Graphics g) {

      Font old = g.getFont();
      Font f = new Font("Times New Roman",Font.BOLD+Font.ITALIC,16);
      g.setFont(f);
      g.setColor(Color.gray);
      g.drawString("IEEE 802.6 DQDB",20,20);
      g.setColor(Color.black);
      g.drawString("IEEE 802.6 DQDB",19,19);
      g.setFont(old);
  }

}


/* ======================================================================= */
/* Klasse hilfeDialog                                                      */
/* ----------------------------------------------------------------------- */
/* Der Dialog stellt einen Hilfe Browser dar                               */
/*                                                                         */
/* ======================================================================= */

class hilfeDialog extends Dialog {

    private Choice auswahl;
    private TextArea text=new TextArea();;

    public hilfeDialog(Fenster F, String Titel,boolean modal) {

        /* Erzeugt den Modalen Dialog                         */
        /* Konstruktor der Superklasse Dialog von speedDialog */
        super(F,Titel,modal);

        auswahl=new Choice();
        auswahl.addItem("General");
        auswahl.addItem("Buttons");
        auswahl.addItem("File/Speed");
        auswahl.addItem("File/Close");
        auswahl.addItem("Ethernet/1 Persistent");
        auswahl.addItem("Ethernet/Non Persistent");
        auswahl.addItem("Animation/1 Persistent or Animation/Non Persistent");
        auswahl.addItem("Animation/Normal transmission");
        auswahl.addItem("Animation/Transmission with collossion");
        auswahl.addItem("Animation/Frame not long enough");
        auswahl.addItem("Help/How to");

        Font f = new Font("COURIR",Font.PLAIN,12);
        text.setFont(f);
        text.setEditable(false);
        text.setText(general());
        add("North", auswahl);
        add("Center",text);
        add("South", new Button ("Schliessen"));
        pack();
        resize(500,500);
        move(200,150);
        show();
    }

    private String general() {
    
        return "General:\n"+
               "--------------------------------------------------------------------------------------------------------------\n"+
               "Within this application you can find three sections\n"+
               "  - The 'Hints section' in the upper part of the window\n"+
               "  - The 'Buttonpanel' on the left side of the window\n"+
               "  - The 'Animationpanel' right beside the Buttonpanel\n"+
               " \n"+
               "To use this animation you first have to select the protocol you \n"+
               "want to simulate. Use the 'Protocol' menu for this selection. \n"+
               "This Version supports the ethernet protocol only !\n"+
               "\n"+
               "after you selected 'Ethernet' you can select the number of workstations\n"+
               "your network contains.\n"+
               "Once you see the network you can select the workstations by clicking at\n"+
               "the monitors. Select senders and receivers of transmissions and then press\n"+
               "the START button on the button panel on the left side.\n"+
               "You can suspend the simulation by pressing the SUSPEND Button, resume with\n"+
               "the RESUME button or enter the step mode by using the STEP button\n"+
               "While a simulation is running you can select other workstations and then\n"+
               "select START again to make them transmit data, while the others are\n"+
               "still transmitting."; 
    }
    
    private String buttons() {
        
        return "Buttons:\n"+
               "----------------------------------------------------------------------------------------------------------------\n"+ 
               "The buttonpanel is on the left side of the animation window\n"+
               "\n\nSTART:\n\n"+
               "The startbutton starts an animation (if there is something to animate).\n"+
               "\n\nSUSPEND\n\n"+
               "Freezes the animation, continue with RESUME\n"+
               "\n\nRESUME\n\n"+
               "Continues a suspended animation\n"+
               "\n\nSTEP\n\n"+
               "Switches into the step mode (You have to suspend the animation first),\n"+
               "which means, that the simulation will be resumed (for a short time)\n"+
               "and then suspend is called again\n"+
               "\n\nRESET ANIM\n\n"+
               "Stops the current animation and resets the simulation\n"+
               "\n\nFASTER\n\n"+
               "Increases the animation speed\n"+
               "\n\nSLOWER\n\n"+
               "Decreases the animation speed\n"+
               "\n\n?\n\n"+
               "Quick help\n"+
               "\n\nCLEAR TEXT\n\n"+
               "Clears the hints window\n"+
               "\n\n1 Persist.\n\n"+
               "Sets the network to the 1 Persistent Mode"+
               "\n\nNon Pers.\n\n"+
               "Sets the network to the Non Persistent Mode";
    
    }

    private String file_speed () {
        
        return "File/Speed:\n"+
               "--------------------------------------------------------------------------------------------------------------\n"+
               "Opens a dialog to enter the value which influences the animation\n"+
               "speed. (1 is fastest, 5 is default)\n"+
               "You also can use the buttons FASTER and SLOWER to change the speed\n";
               
    }

    private String file_close() {
        
        return "File/Close:\n"+
               "--------------------------------------------------------------------------------------------------------------\n"+
               "Closes the application";
    }

    private String protocols_ethernet () {
        
        return "Ethernet/1 Persistent or Ethernet/Non Persistent\n"+
               "--------------------------------------------------------------------------------------------------------------\n"+
               "Selects the Ethernet protocol and displays a dialog window to enter the\n"+
               "number of workstations to use in the network, the network will be created\n"+
               "with the selected persistence";
    }
    
    private String animation() {
    
        return "Animation/1 Persistent or Aniamtion/Non Persistent\n"+
               "--------------------------------------------------------------------------------------------------------------\n"+
               "Predefined animations wtih a 1 or non persistent ethernet protocol.\n"+ 
               "Just hit START\n";
    }

    private String animation_normal () {
        
        return "Animation/(1 Persistent or Non Persistent)/Normal transmission\n"+
               "--------------------------------------------------------------------------------------------------------------\n"+
               "Predefined animation of a normal transmission.\n"+ 
               "Just hit START\n";
    }

    private String animation_collision () {
        
        return "Animation/(1 Persistent or Non Persistent)/Transmission with collision\n"+
               "--------------------------------------------------------------------------------------------------------------\n"+
               "Predefined animation of a tramsmission with collision.\n"+
               "Just hit START\n";
               
        
    }

    private String animation_short() {
        
        return "Animation/(1 Persistent or Non Persistent)/Frame not long enough\n"+
               "--------------------------------------------------------------------------------------------------------------\n"+
               "Predefined animation of a tramsmission with a frame that is too short\n"+
               "In this animation the station (1) which sends first is not able to detect\n"+
               "the collision near (5) because the frame sent by (1) was not long enough, so\n"+
               "that the transmission of (1) is finished before the corrupted date arrives at (1) \n"+
               "Just hit START\n";
    }

    private String help_howto() {
        
        return "Help/How to:\n"+
               "--------------------------------------------------------------------------------------------------------------\n"+
               "Opens this help browser\n";
    }


    public boolean action (Event e, Object o) {
        
        if (e.id == Event.WINDOW_DESTROY) {
  
            dispose();
        }

        if (e.target instanceof Button && "Schliessen".equals(o)) {
  
            dispose();
        }
  
        if (e.target.equals(auswahl)) {
            if (o.equals("General")) {
                text.setText(general());
            }
            
            if (o.equals("Buttons")) {
                text.setText(buttons());
            }
            
            if (o.equals("File/Speed")) {
                text.setText(file_speed());
            }
            if (o.equals("File/Close")) {
                text.setText(file_close());
            }
            if (o.equals("Ethernet/1 Persistent")) {
                text.setText(protocols_ethernet());
            }
            if (o.equals("Ethernet/Non Persistent")) {
                text.setText(protocols_ethernet());
            }
            if (o.equals("Animation/1 Persistent or Animation/Non Persistent")) {
                text.setText(animation());
            }
            if (o.equals("Animation/Normal transmission")) {
                text.setText(animation_normal());
            }
            if (o.equals("Animation/Transmission with collision")) {
                text.setText(animation_collision());
            }
            if (o.equals("Animation/Frame not long enough")) {
                text.setText(animation_short());
            }
            if (o.equals("Help/How to")) {
                text.setText(help_howto());
            }

        }
        return true;
    }

}


/* ======================================================================= */
/* Klasse InfoFenster                                                      */
/* ----------------------------------------------------------------------- */
/* Der Dialog stellt ein InfoFenster dar                                   */
/*                                                                         */
/* ======================================================================= */

/*
class InfoFenster extends Dialog {

}
*/

/* EOF */